// Code generated by pigeon; DO NOT EDIT.

// version expression formatter
// will try to translate expressions in a semver version or version range
// compatible one, like this :
// 1.0.rc.1             --> 1.0.0-rc.1
// <0.8                 --> <0.8.0
// ^5 || <=5.0-beta     --> ^5.0.0 || <=5.0.0-beta
package versionformatter

import (
	"bytes"
	"errors"
	"fmt"
	"io"
	"io/ioutil"
	"math"
	"os"
	"sort"
	"strconv"
	"strings"
	"unicode"
	"unicode/utf8"

	log "github.com/sirupsen/logrus"
)

func Format(expression string, opts ...Option) (string, error) {
	got, err := ParseReader("", strings.NewReader(expression), opts...)
	if err != nil {
		log.Info("👮 In '"+expression+"':\n", err)
		return "", err
	}
	return got.(string), err
}

func toIfaceSlice(v interface{}) []interface{} {
	if v == nil {
		return nil
	}
	return v.([]interface{})
}

var g = &grammar{
	rules: []*rule{
		{
			name: "Input",
			pos:  position{line: 31, col: 1, offset: 713},
			expr: &actionExpr{
				pos: position{line: 31, col: 10, offset: 722},
				run: (*parser).callonInput1,
				expr: &seqExpr{
					pos: position{line: 31, col: 10, offset: 722},
					exprs: []interface{}{
						&ruleRefExpr{
							pos:  position{line: 31, col: 10, offset: 722},
							name: "_",
						},
						&labeledExpr{
							pos:   position{line: 31, col: 12, offset: 724},
							label: "expr",
							expr: &choiceExpr{
								pos: position{line: 31, col: 18, offset: 730},
								alternatives: []interface{}{
									&ruleRefExpr{
										pos:  position{line: 31, col: 18, offset: 730},
										name: "ExpressionList",
									},
									&ruleRefExpr{
										pos:  position{line: 31, col: 35, offset: 747},
										name: "Expression",
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 31, col: 47, offset: 759},
							name: "_",
						},
						&ruleRefExpr{
							pos:  position{line: 31, col: 49, offset: 761},
							name: "EOF",
						},
					},
				},
			},
		},
		{
			name: "ExpressionList",
			pos:  position{line: 36, col: 1, offset: 839},
			expr: &actionExpr{
				pos: position{line: 36, col: 19, offset: 857},
				run: (*parser).callonExpressionList1,
				expr: &seqExpr{
					pos: position{line: 36, col: 19, offset: 857},
					exprs: []interface{}{
						&labeledExpr{
							pos:   position{line: 36, col: 19, offset: 857},
							label: "head",
							expr: &ruleRefExpr{
								pos:  position{line: 36, col: 24, offset: 862},
								name: "Expression",
							},
						},
						&labeledExpr{
							pos:   position{line: 36, col: 35, offset: 873},
							label: "tail",
							expr: &oneOrMoreExpr{
								pos: position{line: 36, col: 40, offset: 878},
								expr: &ruleRefExpr{
									pos:  position{line: 36, col: 41, offset: 879},
									name: "ExpressionSubList",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "ExpressionSubList",
			pos:  position{line: 49, col: 1, offset: 1122},
			expr: &actionExpr{
				pos: position{line: 49, col: 22, offset: 1143},
				run: (*parser).callonExpressionSubList1,
				expr: &seqExpr{
					pos: position{line: 49, col: 22, offset: 1143},
					exprs: []interface{}{
						&labeledExpr{
							pos:   position{line: 49, col: 22, offset: 1143},
							label: "separator",
							expr: &ruleRefExpr{
								pos:  position{line: 49, col: 32, offset: 1153},
								name: "ExpressionSeparator",
							},
						},
						&labeledExpr{
							pos:   position{line: 49, col: 52, offset: 1173},
							label: "expr",
							expr: &ruleRefExpr{
								pos:  position{line: 49, col: 57, offset: 1178},
								name: "Expression",
							},
						},
					},
				},
			},
		},
		{
			name: "Expression",
			pos:  position{line: 55, col: 1, offset: 1299},
			expr: &actionExpr{
				pos: position{line: 55, col: 15, offset: 1313},
				run: (*parser).callonExpression1,
				expr: &labeledExpr{
					pos:   position{line: 55, col: 15, offset: 1313},
					label: "expr",
					expr: &choiceExpr{
						pos: position{line: 55, col: 21, offset: 1319},
						alternatives: []interface{}{
							&ruleRefExpr{
								pos:  position{line: 55, col: 21, offset: 1319},
								name: "Range",
							},
							&ruleRefExpr{
								pos:  position{line: 55, col: 29, offset: 1327},
								name: "SimpleExpression",
							},
						},
					},
				},
			},
		},
		{
			name: "ExpressionSeparator",
			pos:  position{line: 61, col: 1, offset: 1427},
			expr: &actionExpr{
				pos: position{line: 61, col: 24, offset: 1450},
				run: (*parser).callonExpressionSeparator1,
				expr: &choiceExpr{
					pos: position{line: 61, col: 25, offset: 1451},
					alternatives: []interface{}{
						&seqExpr{
							pos: position{line: 61, col: 25, offset: 1451},
							exprs: []interface{}{
								&ruleRefExpr{
									pos:  position{line: 61, col: 25, offset: 1451},
									name: "MandatoryWhiteSpace",
								},
								&litMatcher{
									pos:        position{line: 61, col: 45, offset: 1471},
									val:        "||",
									ignoreCase: false,
								},
								&ruleRefExpr{
									pos:  position{line: 61, col: 50, offset: 1476},
									name: "MandatoryWhiteSpace",
								},
							},
						},
						&seqExpr{
							pos: position{line: 62, col: 24, offset: 1521},
							exprs: []interface{}{
								&ruleRefExpr{
									pos:  position{line: 62, col: 24, offset: 1521},
									name: "MandatoryWhiteSpace",
								},
								&litMatcher{
									pos:        position{line: 62, col: 44, offset: 1541},
									val:        ",",
									ignoreCase: false,
								},
								&ruleRefExpr{
									pos:  position{line: 62, col: 48, offset: 1545},
									name: "MandatoryWhiteSpace",
								},
							},
						},
						&seqExpr{
							pos: position{line: 63, col: 24, offset: 1590},
							exprs: []interface{}{
								&ruleRefExpr{
									pos:  position{line: 63, col: 24, offset: 1590},
									name: "MandatoryWhiteSpace",
								},
								&litMatcher{
									pos:        position{line: 63, col: 44, offset: 1610},
									val:        "|",
									ignoreCase: false,
								},
								&ruleRefExpr{
									pos:  position{line: 63, col: 48, offset: 1614},
									name: "MandatoryWhiteSpace",
								},
							},
						},
						&seqExpr{
							pos: position{line: 64, col: 24, offset: 1659},
							exprs: []interface{}{
								&ruleRefExpr{
									pos:  position{line: 64, col: 24, offset: 1659},
									name: "MandatoryWhiteSpace",
								},
								&litMatcher{
									pos:        position{line: 64, col: 44, offset: 1679},
									val:        "||",
									ignoreCase: false,
								},
							},
						},
						&seqExpr{
							pos: position{line: 65, col: 24, offset: 1709},
							exprs: []interface{}{
								&ruleRefExpr{
									pos:  position{line: 65, col: 24, offset: 1709},
									name: "MandatoryWhiteSpace",
								},
								&litMatcher{
									pos:        position{line: 65, col: 44, offset: 1729},
									val:        ",",
									ignoreCase: false,
								},
							},
						},
						&seqExpr{
							pos: position{line: 66, col: 24, offset: 1758},
							exprs: []interface{}{
								&ruleRefExpr{
									pos:  position{line: 66, col: 24, offset: 1758},
									name: "MandatoryWhiteSpace",
								},
								&litMatcher{
									pos:        position{line: 66, col: 44, offset: 1778},
									val:        "|",
									ignoreCase: false,
								},
							},
						},
						&seqExpr{
							pos: position{line: 67, col: 24, offset: 1807},
							exprs: []interface{}{
								&litMatcher{
									pos:        position{line: 67, col: 24, offset: 1807},
									val:        "||",
									ignoreCase: false,
								},
								&ruleRefExpr{
									pos:  position{line: 67, col: 29, offset: 1812},
									name: "MandatoryWhiteSpace",
								},
							},
						},
						&seqExpr{
							pos: position{line: 68, col: 24, offset: 1857},
							exprs: []interface{}{
								&litMatcher{
									pos:        position{line: 68, col: 24, offset: 1857},
									val:        ",",
									ignoreCase: false,
								},
								&ruleRefExpr{
									pos:  position{line: 68, col: 28, offset: 1861},
									name: "MandatoryWhiteSpace",
								},
							},
						},
						&seqExpr{
							pos: position{line: 69, col: 24, offset: 1906},
							exprs: []interface{}{
								&litMatcher{
									pos:        position{line: 69, col: 24, offset: 1906},
									val:        "|",
									ignoreCase: false,
								},
								&ruleRefExpr{
									pos:  position{line: 69, col: 28, offset: 1910},
									name: "MandatoryWhiteSpace",
								},
							},
						},
						&litMatcher{
							pos:        position{line: 70, col: 24, offset: 1955},
							val:        "||",
							ignoreCase: false,
						},
						&litMatcher{
							pos:        position{line: 71, col: 24, offset: 1985},
							val:        ",",
							ignoreCase: false,
						},
						&litMatcher{
							pos:        position{line: 72, col: 24, offset: 2014},
							val:        "|",
							ignoreCase: false,
						},
						&ruleRefExpr{
							pos:  position{line: 73, col: 24, offset: 2043},
							name: "MandatoryWhiteSpace",
						},
					},
				},
			},
		},
		{
			name: "Range",
			pos:  position{line: 78, col: 1, offset: 2157},
			expr: &choiceExpr{
				pos: position{line: 78, col: 10, offset: 2166},
				alternatives: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 78, col: 10, offset: 2166},
						name: "PrimitiveRange",
					},
					&ruleRefExpr{
						pos:  position{line: 78, col: 27, offset: 2183},
						name: "HyphenRange",
					},
					&ruleRefExpr{
						pos:  position{line: 78, col: 41, offset: 2197},
						name: "TildeRange",
					},
					&ruleRefExpr{
						pos:  position{line: 78, col: 54, offset: 2210},
						name: "CaretRange",
					},
					&ruleRefExpr{
						pos:  position{line: 78, col: 67, offset: 2223},
						name: "XRange",
					},
				},
			},
		},
		{
			name: "PrimitiveRange",
			pos:  position{line: 80, col: 1, offset: 2231},
			expr: &choiceExpr{
				pos: position{line: 80, col: 19, offset: 2249},
				alternatives: []interface{}{
					&actionExpr{
						pos: position{line: 80, col: 19, offset: 2249},
						run: (*parser).callonPrimitiveRange2,
						expr: &seqExpr{
							pos: position{line: 80, col: 20, offset: 2250},
							exprs: []interface{}{
								&labeledExpr{
									pos:   position{line: 80, col: 20, offset: 2250},
									label: "startop",
									expr: &ruleRefExpr{
										pos:  position{line: 80, col: 28, offset: 2258},
										name: "StartRangeOperator",
									},
								},
								&labeledExpr{
									pos:   position{line: 80, col: 47, offset: 2277},
									label: "start",
									expr: &ruleRefExpr{
										pos:  position{line: 80, col: 53, offset: 2283},
										name: "Version",
									},
								},
								&labeledExpr{
									pos:   position{line: 80, col: 61, offset: 2291},
									label: "s",
									expr: &ruleRefExpr{
										pos:  position{line: 80, col: 63, offset: 2293},
										name: "InRangeSeparator",
									},
								},
								&labeledExpr{
									pos:   position{line: 80, col: 80, offset: 2310},
									label: "endop",
									expr: &ruleRefExpr{
										pos:  position{line: 80, col: 86, offset: 2316},
										name: "EndRangeOperator",
									},
								},
								&labeledExpr{
									pos:   position{line: 80, col: 103, offset: 2333},
									label: "end",
									expr: &ruleRefExpr{
										pos:  position{line: 80, col: 107, offset: 2337},
										name: "Version",
									},
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 84, col: 5, offset: 2510},
						run: (*parser).callonPrimitiveRange14,
						expr: &seqExpr{
							pos: position{line: 84, col: 6, offset: 2511},
							exprs: []interface{}{
								&labeledExpr{
									pos:   position{line: 84, col: 6, offset: 2511},
									label: "startop",
									expr: &ruleRefExpr{
										pos:  position{line: 84, col: 14, offset: 2519},
										name: "EndRangeOperator",
									},
								},
								&labeledExpr{
									pos:   position{line: 84, col: 31, offset: 2536},
									label: "start",
									expr: &ruleRefExpr{
										pos:  position{line: 84, col: 37, offset: 2542},
										name: "Version",
									},
								},
								&labeledExpr{
									pos:   position{line: 84, col: 45, offset: 2550},
									label: "s",
									expr: &ruleRefExpr{
										pos:  position{line: 84, col: 47, offset: 2552},
										name: "InRangeSeparator",
									},
								},
								&labeledExpr{
									pos:   position{line: 84, col: 64, offset: 2569},
									label: "endop",
									expr: &ruleRefExpr{
										pos:  position{line: 84, col: 70, offset: 2575},
										name: "StartRangeOperator",
									},
								},
								&labeledExpr{
									pos:   position{line: 84, col: 89, offset: 2594},
									label: "end",
									expr: &ruleRefExpr{
										pos:  position{line: 84, col: 93, offset: 2598},
										name: "Version",
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "StartRangeOperator",
			pos:  position{line: 90, col: 1, offset: 2779},
			expr: &choiceExpr{
				pos: position{line: 90, col: 23, offset: 2801},
				alternatives: []interface{}{
					&litMatcher{
						pos:        position{line: 90, col: 23, offset: 2801},
						val:        ">=",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 90, col: 30, offset: 2808},
						val:        ">",
						ignoreCase: false,
					},
				},
			},
		},
		{
			name: "EndRangeOperator",
			pos:  position{line: 92, col: 1, offset: 2813},
			expr: &choiceExpr{
				pos: position{line: 92, col: 21, offset: 2833},
				alternatives: []interface{}{
					&litMatcher{
						pos:        position{line: 92, col: 21, offset: 2833},
						val:        "<=",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 92, col: 28, offset: 2840},
						val:        "<",
						ignoreCase: false,
					},
				},
			},
		},
		{
			name: "InRangeSeparator",
			pos:  position{line: 94, col: 1, offset: 2845},
			expr: &choiceExpr{
				pos: position{line: 94, col: 21, offset: 2865},
				alternatives: []interface{}{
					&seqExpr{
						pos: position{line: 94, col: 21, offset: 2865},
						exprs: []interface{}{
							&ruleRefExpr{
								pos:  position{line: 94, col: 21, offset: 2865},
								name: "MandatoryWhiteSpace",
							},
							&litMatcher{
								pos:        position{line: 94, col: 41, offset: 2885},
								val:        ",",
								ignoreCase: false,
							},
							&ruleRefExpr{
								pos:  position{line: 94, col: 45, offset: 2889},
								name: "MandatoryWhiteSpace",
							},
						},
					},
					&seqExpr{
						pos: position{line: 95, col: 21, offset: 2931},
						exprs: []interface{}{
							&ruleRefExpr{
								pos:  position{line: 95, col: 21, offset: 2931},
								name: "MandatoryWhiteSpace",
							},
							&litMatcher{
								pos:        position{line: 95, col: 41, offset: 2951},
								val:        "|",
								ignoreCase: false,
							},
							&ruleRefExpr{
								pos:  position{line: 95, col: 45, offset: 2955},
								name: "MandatoryWhiteSpace",
							},
						},
					},
					&seqExpr{
						pos: position{line: 96, col: 21, offset: 2997},
						exprs: []interface{}{
							&ruleRefExpr{
								pos:  position{line: 96, col: 21, offset: 2997},
								name: "MandatoryWhiteSpace",
							},
							&litMatcher{
								pos:        position{line: 96, col: 41, offset: 3017},
								val:        ",",
								ignoreCase: false,
							},
						},
					},
					&seqExpr{
						pos: position{line: 97, col: 21, offset: 3043},
						exprs: []interface{}{
							&ruleRefExpr{
								pos:  position{line: 97, col: 21, offset: 3043},
								name: "MandatoryWhiteSpace",
							},
							&litMatcher{
								pos:        position{line: 97, col: 41, offset: 3063},
								val:        "|",
								ignoreCase: false,
							},
						},
					},
					&seqExpr{
						pos: position{line: 98, col: 21, offset: 3089},
						exprs: []interface{}{
							&litMatcher{
								pos:        position{line: 98, col: 21, offset: 3089},
								val:        ",",
								ignoreCase: false,
							},
							&ruleRefExpr{
								pos:  position{line: 98, col: 25, offset: 3093},
								name: "MandatoryWhiteSpace",
							},
						},
					},
					&seqExpr{
						pos: position{line: 99, col: 21, offset: 3135},
						exprs: []interface{}{
							&litMatcher{
								pos:        position{line: 99, col: 21, offset: 3135},
								val:        "|",
								ignoreCase: false,
							},
							&ruleRefExpr{
								pos:  position{line: 99, col: 25, offset: 3139},
								name: "MandatoryWhiteSpace",
							},
						},
					},
					&litMatcher{
						pos:        position{line: 100, col: 21, offset: 3181},
						val:        ",",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 101, col: 21, offset: 3207},
						val:        "|",
						ignoreCase: false,
					},
					&actionExpr{
						pos: position{line: 102, col: 21, offset: 3233},
						run: (*parser).callonInRangeSeparator24,
						expr: &ruleRefExpr{
							pos:  position{line: 102, col: 21, offset: 3233},
							name: "MandatoryWhiteSpace",
						},
					},
				},
			},
		},
		{
			name: "HyphenOperator",
			pos:  position{line: 107, col: 1, offset: 3352},
			expr: &choiceExpr{
				pos: position{line: 107, col: 19, offset: 3370},
				alternatives: []interface{}{
					&seqExpr{
						pos: position{line: 107, col: 19, offset: 3370},
						exprs: []interface{}{
							&ruleRefExpr{
								pos:  position{line: 107, col: 19, offset: 3370},
								name: "MandatoryWhiteSpace",
							},
							&litMatcher{
								pos:        position{line: 107, col: 39, offset: 3390},
								val:        "-",
								ignoreCase: false,
							},
							&ruleRefExpr{
								pos:  position{line: 107, col: 43, offset: 3394},
								name: "MandatoryWhiteSpace",
							},
						},
					},
					&seqExpr{
						pos: position{line: 108, col: 19, offset: 3434},
						exprs: []interface{}{
							&ruleRefExpr{
								pos:  position{line: 108, col: 19, offset: 3434},
								name: "MandatoryWhiteSpace",
							},
							&litMatcher{
								pos:        position{line: 108, col: 39, offset: 3454},
								val:        "-",
								ignoreCase: false,
							},
						},
					},
					&seqExpr{
						pos: position{line: 109, col: 19, offset: 3478},
						exprs: []interface{}{
							&litMatcher{
								pos:        position{line: 109, col: 19, offset: 3478},
								val:        "-",
								ignoreCase: false,
							},
							&ruleRefExpr{
								pos:  position{line: 109, col: 23, offset: 3482},
								name: "MandatoryWhiteSpace",
							},
						},
					},
					&litMatcher{
						pos:        position{line: 110, col: 19, offset: 3522},
						val:        "-",
						ignoreCase: false,
					},
				},
			},
		},
		{
			name: "HyphenRange",
			pos:  position{line: 112, col: 1, offset: 3527},
			expr: &actionExpr{
				pos: position{line: 112, col: 16, offset: 3542},
				run: (*parser).callonHyphenRange1,
				expr: &seqExpr{
					pos: position{line: 112, col: 17, offset: 3543},
					exprs: []interface{}{
						&labeledExpr{
							pos:   position{line: 112, col: 17, offset: 3543},
							label: "start",
							expr: &ruleRefExpr{
								pos:  position{line: 112, col: 23, offset: 3549},
								name: "Version",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 112, col: 31, offset: 3557},
							name: "HyphenOperator",
						},
						&labeledExpr{
							pos:   position{line: 112, col: 46, offset: 3572},
							label: "end",
							expr: &ruleRefExpr{
								pos:  position{line: 112, col: 50, offset: 3576},
								name: "Version",
							},
						},
					},
				},
			},
		},
		{
			name: "XRange",
			pos:  position{line: 118, col: 1, offset: 3692},
			expr: &actionExpr{
				pos: position{line: 118, col: 11, offset: 3702},
				run: (*parser).callonXRange1,
				expr: &labeledExpr{
					pos:   position{line: 118, col: 11, offset: 3702},
					label: "version",
					expr: &ruleRefExpr{
						pos:  position{line: 118, col: 19, offset: 3710},
						name: "Version",
					},
				},
			},
		},
		{
			name: "TildeRange",
			pos:  position{line: 124, col: 1, offset: 3799},
			expr: &actionExpr{
				pos: position{line: 124, col: 15, offset: 3813},
				run: (*parser).callonTildeRange1,
				expr: &seqExpr{
					pos: position{line: 124, col: 16, offset: 3814},
					exprs: []interface{}{
						&litMatcher{
							pos:        position{line: 124, col: 16, offset: 3814},
							val:        "~",
							ignoreCase: false,
						},
						&labeledExpr{
							pos:   position{line: 124, col: 20, offset: 3818},
							label: "version",
							expr: &ruleRefExpr{
								pos:  position{line: 124, col: 28, offset: 3826},
								name: "Version",
							},
						},
					},
				},
			},
		},
		{
			name: "CaretRange",
			pos:  position{line: 130, col: 1, offset: 3926},
			expr: &actionExpr{
				pos: position{line: 130, col: 15, offset: 3940},
				run: (*parser).callonCaretRange1,
				expr: &seqExpr{
					pos: position{line: 130, col: 16, offset: 3941},
					exprs: []interface{}{
						&litMatcher{
							pos:        position{line: 130, col: 16, offset: 3941},
							val:        "^",
							ignoreCase: false,
						},
						&labeledExpr{
							pos:   position{line: 130, col: 20, offset: 3945},
							label: "version",
							expr: &ruleRefExpr{
								pos:  position{line: 130, col: 28, offset: 3953},
								name: "Version",
							},
						},
					},
				},
			},
		},
		{
			name: "SimpleExpression",
			pos:  position{line: 136, col: 1, offset: 4053},
			expr: &actionExpr{
				pos: position{line: 136, col: 21, offset: 4073},
				run: (*parser).callonSimpleExpression1,
				expr: &labeledExpr{
					pos:   position{line: 136, col: 21, offset: 4073},
					label: "expr",
					expr: &ruleRefExpr{
						pos:  position{line: 136, col: 26, offset: 4078},
						name: "UnaryAndVersion",
					},
				},
			},
		},
		{
			name: "UnaryAndVersion",
			pos:  position{line: 141, col: 1, offset: 4179},
			expr: &actionExpr{
				pos: position{line: 141, col: 20, offset: 4198},
				run: (*parser).callonUnaryAndVersion1,
				expr: &seqExpr{
					pos: position{line: 141, col: 20, offset: 4198},
					exprs: []interface{}{
						&labeledExpr{
							pos:   position{line: 141, col: 20, offset: 4198},
							label: "unary",
							expr: &ruleRefExpr{
								pos:  position{line: 141, col: 26, offset: 4204},
								name: "OptionalUnary",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 141, col: 40, offset: 4218},
							name: "_",
						},
						&labeledExpr{
							pos:   position{line: 141, col: 42, offset: 4220},
							label: "version",
							expr: &ruleRefExpr{
								pos:  position{line: 141, col: 50, offset: 4228},
								name: "Version",
							},
						},
					},
				},
			},
		},
		{
			name: "OptionalUnary",
			pos:  position{line: 145, col: 1, offset: 4289},
			expr: &actionExpr{
				pos: position{line: 145, col: 18, offset: 4306},
				run: (*parser).callonOptionalUnary1,
				expr: &labeledExpr{
					pos:   position{line: 145, col: 18, offset: 4306},
					label: "op",
					expr: &zeroOrOneExpr{
						pos: position{line: 145, col: 21, offset: 4309},
						expr: &ruleRefExpr{
							pos:  position{line: 145, col: 21, offset: 4309},
							name: "UnaryOperator",
						},
					},
				},
			},
		},
		{
			name: "Version",
			pos:  position{line: 152, col: 1, offset: 4396},
			expr: &actionExpr{
				pos: position{line: 152, col: 12, offset: 4407},
				run: (*parser).callonVersion1,
				expr: &seqExpr{
					pos: position{line: 152, col: 12, offset: 4407},
					exprs: []interface{}{
						&labeledExpr{
							pos:   position{line: 152, col: 12, offset: 4407},
							label: "head",
							expr: &ruleRefExpr{
								pos:  position{line: 152, col: 17, offset: 4412},
								name: "Major",
							},
						},
						&labeledExpr{
							pos:   position{line: 152, col: 23, offset: 4418},
							label: "tail",
							expr: &ruleRefExpr{
								pos:  position{line: 152, col: 28, offset: 4423},
								name: "OptionalMinorPatchPreRelease",
							},
						},
					},
				},
			},
		},
		{
			name: "Major",
			pos:  position{line: 159, col: 1, offset: 4598},
			expr: &ruleRefExpr{
				pos:  position{line: 159, col: 10, offset: 4607},
				name: "VersionPart",
			},
		},
		{
			name: "OptionalMinorPatchPreRelease",
			pos:  position{line: 161, col: 1, offset: 4620},
			expr: &actionExpr{
				pos: position{line: 161, col: 33, offset: 4652},
				run: (*parser).callonOptionalMinorPatchPreRelease1,
				expr: &seqExpr{
					pos: position{line: 161, col: 33, offset: 4652},
					exprs: []interface{}{
						&labeledExpr{
							pos:   position{line: 161, col: 33, offset: 4652},
							label: "head",
							expr: &ruleRefExpr{
								pos:  position{line: 161, col: 38, offset: 4657},
								name: "OptionalDotMinor",
							},
						},
						&labeledExpr{
							pos:   position{line: 161, col: 55, offset: 4674},
							label: "tail",
							expr: &ruleRefExpr{
								pos:  position{line: 161, col: 60, offset: 4679},
								name: "OptionalPatchPreRelease",
							},
						},
					},
				},
			},
		},
		{
			name: "OptionalDotMinor",
			pos:  position{line: 165, col: 1, offset: 4752},
			expr: &actionExpr{
				pos: position{line: 165, col: 21, offset: 4772},
				run: (*parser).callonOptionalDotMinor1,
				expr: &labeledExpr{
					pos:   position{line: 165, col: 21, offset: 4772},
					label: "minor",
					expr: &zeroOrOneExpr{
						pos: position{line: 165, col: 27, offset: 4778},
						expr: &ruleRefExpr{
							pos:  position{line: 165, col: 27, offset: 4778},
							name: "DotVersionPart",
						},
					},
				},
			},
		},
		{
			name: "Minor",
			pos:  position{line: 173, col: 1, offset: 4907},
			expr: &ruleRefExpr{
				pos:  position{line: 173, col: 10, offset: 4916},
				name: "VersionPart",
			},
		},
		{
			name: "OptionalPatchPreRelease",
			pos:  position{line: 175, col: 1, offset: 4929},
			expr: &actionExpr{
				pos: position{line: 175, col: 28, offset: 4956},
				run: (*parser).callonOptionalPatchPreRelease1,
				expr: &seqExpr{
					pos: position{line: 175, col: 28, offset: 4956},
					exprs: []interface{}{
						&labeledExpr{
							pos:   position{line: 175, col: 28, offset: 4956},
							label: "head",
							expr: &ruleRefExpr{
								pos:  position{line: 175, col: 33, offset: 4961},
								name: "OptionalDotPatch",
							},
						},
						&labeledExpr{
							pos:   position{line: 175, col: 50, offset: 4978},
							label: "tail",
							expr: &ruleRefExpr{
								pos:  position{line: 175, col: 55, offset: 4983},
								name: "OptionalPreRelease",
							},
						},
					},
				},
			},
		},
		{
			name: "OptionalDotPatch",
			pos:  position{line: 184, col: 1, offset: 5145},
			expr: &actionExpr{
				pos: position{line: 184, col: 21, offset: 5165},
				run: (*parser).callonOptionalDotPatch1,
				expr: &labeledExpr{
					pos:   position{line: 184, col: 21, offset: 5165},
					label: "patch",
					expr: &zeroOrOneExpr{
						pos: position{line: 184, col: 27, offset: 5171},
						expr: &ruleRefExpr{
							pos:  position{line: 184, col: 27, offset: 5171},
							name: "DotVersionPart",
						},
					},
				},
			},
		},
		{
			name: "DotVersionPart",
			pos:  position{line: 191, col: 1, offset: 5267},
			expr: &actionExpr{
				pos: position{line: 191, col: 19, offset: 5285},
				run: (*parser).callonDotVersionPart1,
				expr: &seqExpr{
					pos: position{line: 191, col: 19, offset: 5285},
					exprs: []interface{}{
						&ruleRefExpr{
							pos:  position{line: 191, col: 19, offset: 5285},
							name: "Dot",
						},
						&labeledExpr{
							pos:   position{line: 191, col: 23, offset: 5289},
							label: "n",
							expr: &ruleRefExpr{
								pos:  position{line: 191, col: 25, offset: 5291},
								name: "VersionPart",
							},
						},
					},
				},
			},
		},
		{
			name: "Patch",
			pos:  position{line: 198, col: 1, offset: 5381},
			expr: &ruleRefExpr{
				pos:  position{line: 198, col: 10, offset: 5390},
				name: "VersionPart",
			},
		},
		{
			name: "OptionalPreRelease",
			pos:  position{line: 200, col: 1, offset: 5403},
			expr: &actionExpr{
				pos: position{line: 200, col: 23, offset: 5425},
				run: (*parser).callonOptionalPreRelease1,
				expr: &seqExpr{
					pos: position{line: 200, col: 23, offset: 5425},
					exprs: []interface{}{
						&zeroOrOneExpr{
							pos: position{line: 200, col: 23, offset: 5425},
							expr: &choiceExpr{
								pos: position{line: 200, col: 24, offset: 5426},
								alternatives: []interface{}{
									&ruleRefExpr{
										pos:  position{line: 200, col: 24, offset: 5426},
										name: "Dash",
									},
									&ruleRefExpr{
										pos:  position{line: 200, col: 29, offset: 5431},
										name: "Dot",
									},
									&ruleRefExpr{
										pos:  position{line: 200, col: 33, offset: 5435},
										name: "Plus",
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 200, col: 40, offset: 5442},
							label: "prerelease",
							expr: &zeroOrOneExpr{
								pos: position{line: 200, col: 51, offset: 5453},
								expr: &ruleRefExpr{
									pos:  position{line: 200, col: 51, offset: 5453},
									name: "PreRelease",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "PreRelease",
			pos:  position{line: 211, col: 1, offset: 5659},
			expr: &actionExpr{
				pos: position{line: 211, col: 15, offset: 5673},
				run: (*parser).callonPreRelease1,
				expr: &zeroOrMoreExpr{
					pos: position{line: 211, col: 15, offset: 5673},
					expr: &ruleRefExpr{
						pos:  position{line: 211, col: 15, offset: 5673},
						name: "PreReleaseContent",
					},
				},
			},
		},
		{
			name: "PreReleaseContent",
			pos:  position{line: 215, col: 1, offset: 5726},
			expr: &choiceExpr{
				pos: position{line: 215, col: 22, offset: 5747},
				alternatives: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 215, col: 22, offset: 5747},
						name: "VersionPart",
					},
					&ruleRefExpr{
						pos:  position{line: 215, col: 36, offset: 5761},
						name: "Word",
					},
					&ruleRefExpr{
						pos:  position{line: 215, col: 43, offset: 5768},
						name: "Dot",
					},
					&ruleRefExpr{
						pos:  position{line: 215, col: 49, offset: 5774},
						name: "Dash",
					},
					&ruleRefExpr{
						pos:  position{line: 215, col: 56, offset: 5781},
						name: "Plus",
					},
				},
			},
		},
		{
			name:        "Dot",
			displayName: "\".\"",
			pos:         position{line: 217, col: 1, offset: 5787},
			expr: &actionExpr{
				pos: position{line: 217, col: 12, offset: 5798},
				run: (*parser).callonDot1,
				expr: &charClassMatcher{
					pos:        position{line: 217, col: 12, offset: 5798},
					val:        "[.]",
					chars:      []rune{'.'},
					ignoreCase: false,
					inverted:   false,
				},
			},
		},
		{
			name:        "Dash",
			displayName: "\"-\"",
			pos:         position{line: 221, col: 1, offset: 5825},
			expr: &actionExpr{
				pos: position{line: 221, col: 13, offset: 5837},
				run: (*parser).callonDash1,
				expr: &charClassMatcher{
					pos:        position{line: 221, col: 13, offset: 5837},
					val:        "[-]",
					chars:      []rune{'-'},
					ignoreCase: false,
					inverted:   false,
				},
			},
		},
		{
			name:        "Plus",
			displayName: "\"+\"",
			pos:         position{line: 225, col: 1, offset: 5864},
			expr: &actionExpr{
				pos: position{line: 225, col: 13, offset: 5876},
				run: (*parser).callonPlus1,
				expr: &charClassMatcher{
					pos:        position{line: 225, col: 13, offset: 5876},
					val:        "[+]",
					chars:      []rune{'+'},
					ignoreCase: false,
					inverted:   false,
				},
			},
		},
		{
			name: "Word",
			pos:  position{line: 229, col: 1, offset: 5903},
			expr: &actionExpr{
				pos: position{line: 229, col: 9, offset: 5911},
				run: (*parser).callonWord1,
				expr: &oneOrMoreExpr{
					pos: position{line: 229, col: 9, offset: 5911},
					expr: &charClassMatcher{
						pos:        position{line: 229, col: 9, offset: 5911},
						val:        "[a-zA-Z]",
						ranges:     []rune{'a', 'z', 'A', 'Z'},
						ignoreCase: false,
						inverted:   false,
					},
				},
			},
		},
		{
			name: "VersionPart",
			pos:  position{line: 233, col: 1, offset: 5955},
			expr: &choiceExpr{
				pos: position{line: 233, col: 16, offset: 5970},
				alternatives: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 233, col: 16, offset: 5970},
						name: "Wildcard",
					},
					&ruleRefExpr{
						pos:  position{line: 233, col: 27, offset: 5981},
						name: "Number",
					},
				},
			},
		},
		{
			name: "Wildcard",
			pos:  position{line: 235, col: 1, offset: 5989},
			expr: &actionExpr{
				pos: position{line: 235, col: 13, offset: 6001},
				run: (*parser).callonWildcard1,
				expr: &labeledExpr{
					pos:   position{line: 235, col: 13, offset: 6001},
					label: "wildcard",
					expr: &choiceExpr{
						pos: position{line: 235, col: 23, offset: 6011},
						alternatives: []interface{}{
							&litMatcher{
								pos:        position{line: 235, col: 23, offset: 6011},
								val:        "x",
								ignoreCase: false,
							},
							&litMatcher{
								pos:        position{line: 235, col: 29, offset: 6017},
								val:        "X",
								ignoreCase: false,
							},
							&litMatcher{
								pos:        position{line: 235, col: 35, offset: 6023},
								val:        "*",
								ignoreCase: false,
							},
						},
					},
				},
			},
		},
		{
			name:        "Number",
			displayName: "\"number\"",
			pos:         position{line: 239, col: 1, offset: 6074},
			expr: &actionExpr{
				pos: position{line: 239, col: 20, offset: 6093},
				run: (*parser).callonNumber1,
				expr: &oneOrMoreExpr{
					pos: position{line: 239, col: 20, offset: 6093},
					expr: &charClassMatcher{
						pos:        position{line: 239, col: 20, offset: 6093},
						val:        "[0-9]",
						ranges:     []rune{'0', '9'},
						ignoreCase: false,
						inverted:   false,
					},
				},
			},
		},
		{
			name: "Comparator",
			pos:  position{line: 250, col: 1, offset: 6351},
			expr: &choiceExpr{
				pos: position{line: 250, col: 15, offset: 6365},
				alternatives: []interface{}{
					&litMatcher{
						pos:        position{line: 250, col: 15, offset: 6365},
						val:        ">=",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 250, col: 22, offset: 6372},
						val:        "<=",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 250, col: 29, offset: 6379},
						val:        "<",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 250, col: 35, offset: 6385},
						val:        ">",
						ignoreCase: false,
					},
					&actionExpr{
						pos: position{line: 250, col: 41, offset: 6391},
						run: (*parser).callonComparator6,
						expr: &litMatcher{
							pos:        position{line: 250, col: 41, offset: 6391},
							val:        "=",
							ignoreCase: false,
						},
					},
				},
			},
		},
		{
			name:        "UnaryOperator",
			displayName: "\"unary\"",
			pos:         position{line: 255, col: 1, offset: 6468},
			expr: &actionExpr{
				pos: position{line: 255, col: 26, offset: 6493},
				run: (*parser).callonUnaryOperator1,
				expr: &labeledExpr{
					pos:   position{line: 255, col: 26, offset: 6493},
					label: "op",
					expr: &zeroOrOneExpr{
						pos: position{line: 255, col: 29, offset: 6496},
						expr: &choiceExpr{
							pos: position{line: 255, col: 30, offset: 6497},
							alternatives: []interface{}{
								&litMatcher{
									pos:        position{line: 255, col: 30, offset: 6497},
									val:        "!=",
									ignoreCase: false,
								},
								&litMatcher{
									pos:        position{line: 255, col: 37, offset: 6504},
									val:        "==",
									ignoreCase: false,
								},
								&litMatcher{
									pos:        position{line: 255, col: 43, offset: 6510},
									val:        "<=",
									ignoreCase: false,
								},
								&litMatcher{
									pos:        position{line: 255, col: 50, offset: 6517},
									val:        ">=",
									ignoreCase: false,
								},
								&litMatcher{
									pos:        position{line: 255, col: 57, offset: 6524},
									val:        "<",
									ignoreCase: false,
								},
								&litMatcher{
									pos:        position{line: 255, col: 63, offset: 6530},
									val:        ">",
									ignoreCase: false,
								},
								&litMatcher{
									pos:        position{line: 255, col: 69, offset: 6536},
									val:        "=",
									ignoreCase: false,
								},
								&litMatcher{
									pos:        position{line: 255, col: 75, offset: 6542},
									val:        "!",
									ignoreCase: false,
								},
							},
						},
					},
				},
			},
		},
		{
			name:        "MandatoryWhiteSpace",
			displayName: "\"mandatory whitespace\"",
			pos:         position{line: 262, col: 1, offset: 6630},
			expr: &actionExpr{
				pos: position{line: 262, col: 47, offset: 6676},
				run: (*parser).callonMandatoryWhiteSpace1,
				expr: &oneOrMoreExpr{
					pos: position{line: 262, col: 47, offset: 6676},
					expr: &charClassMatcher{
						pos:        position{line: 262, col: 47, offset: 6676},
						val:        "[ \\t\\n\\r]",
						chars:      []rune{' ', '\t', '\n', '\r'},
						ignoreCase: false,
						inverted:   false,
					},
				},
			},
		},
		{
			name:        "_",
			displayName: "\"whitespace\"",
			pos:         position{line: 266, col: 1, offset: 6718},
			expr: &zeroOrMoreExpr{
				pos: position{line: 266, col: 19, offset: 6736},
				expr: &charClassMatcher{
					pos:        position{line: 266, col: 19, offset: 6736},
					val:        "[ \\t\\n\\r]",
					chars:      []rune{' ', '\t', '\n', '\r'},
					ignoreCase: false,
					inverted:   false,
				},
			},
		},
		{
			name: "EOF",
			pos:  position{line: 268, col: 1, offset: 6748},
			expr: &notExpr{
				pos: position{line: 268, col: 8, offset: 6755},
				expr: &anyMatcher{
					line: 268, col: 9, offset: 6756,
				},
			},
		},
	},
}

func (c *current) onInput1(expr interface{}) (interface{}, error) {
	log.Debug("👮 Input", expr.(string))
	return expr.(string), nil
}

func (p *parser) callonInput1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInput1(stack["expr"])
}

func (c *current) onExpressionList1(head, tail interface{}) (interface{}, error) {
	if tail == nil {
		return head, nil
	}
	tailSl := toIfaceSlice(tail)
	res := head.(string)
	for _, part := range tailSl {
		res += part.(string)
	}
	log.Debug("👮 ExpressionList", res)
	return res, nil
}

func (p *parser) callonExpressionList1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onExpressionList1(stack["head"], stack["tail"])
}

func (c *current) onExpressionSubList1(separator, expr interface{}) (interface{}, error) {
	res := separator.(string) + expr.(string)
	log.Debug("👮 ExpressionSubList", res)
	return res, nil
}

func (p *parser) callonExpressionSubList1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onExpressionSubList1(stack["separator"], stack["expr"])
}

func (c *current) onExpression1(expr interface{}) (interface{}, error) {
	res := expr.(string)
	log.Debug("👮 Expression", res)
	return res, nil
}

func (p *parser) callonExpression1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onExpression1(stack["expr"])
}

func (c *current) onExpressionSeparator1() (interface{}, error) {
	log.Debug("👮 ExpressionSeparator", string(c.text), "👉 ||")
	return " || ", nil
}

func (p *parser) callonExpressionSeparator1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onExpressionSeparator1()
}

func (c *current) onPrimitiveRange2(startop, start, s, endop, end interface{}) (interface{}, error) {
	res := string(startop.([]uint8)) + start.(string) + ", " + string(endop.([]uint8)) + end.(string)
	log.Debug("👮 PrimitiveRange", res)
	return res, nil
}

func (p *parser) callonPrimitiveRange2() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onPrimitiveRange2(stack["startop"], stack["start"], stack["s"], stack["endop"], stack["end"])
}

func (c *current) onPrimitiveRange14(startop, start, s, endop, end interface{}) (interface{}, error) {
	res := string(endop.([]uint8)) + end.(string) + ", " + string(startop.([]uint8)) + start.(string)
	log.Debug("👮 Reversed PrimitiveRange", res)
	return res, nil
}

func (p *parser) callonPrimitiveRange14() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onPrimitiveRange14(stack["startop"], stack["start"], stack["s"], stack["endop"], stack["end"])
}

func (c *current) onInRangeSeparator24() (interface{}, error) {
	log.Debug("👮 InRangeSeparator", string(c.text), "👉 \" \"")
	return string(", "), nil
}

func (p *parser) callonInRangeSeparator24() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInRangeSeparator24()
}

func (c *current) onHyphenRange1(start, end interface{}) (interface{}, error) {
	var res = start.(string) + " - " + end.(string)
	log.Debug("👮 HyphenRange", res)
	return res, nil
}

func (p *parser) callonHyphenRange1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onHyphenRange1(stack["start"], stack["end"])
}

func (c *current) onXRange1(version interface{}) (interface{}, error) {
	var res = version.(string)
	log.Debug("👮 XRange", res)
	return res, nil
}

func (p *parser) callonXRange1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onXRange1(stack["version"])
}

func (c *current) onTildeRange1(version interface{}) (interface{}, error) {
	var res = "~" + version.(string)
	log.Debug("👮 TildeRange", res)
	return res, nil
}

func (p *parser) callonTildeRange1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onTildeRange1(stack["version"])
}

func (c *current) onCaretRange1(version interface{}) (interface{}, error) {
	var res = "^" + version.(string)
	log.Debug("👮 CaretRange", res)
	return res, nil
}

func (p *parser) callonCaretRange1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onCaretRange1(stack["version"])
}

func (c *current) onSimpleExpression1(expr interface{}) (interface{}, error) {
	log.Debug("👮 SimpleExpression", expr.(string))
	return expr.(string), nil
}

func (p *parser) callonSimpleExpression1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSimpleExpression1(stack["expr"])
}

func (c *current) onUnaryAndVersion1(unary, version interface{}) (interface{}, error) {
	return unary.(string) + version.(string), nil
}

func (p *parser) callonUnaryAndVersion1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onUnaryAndVersion1(stack["unary"], stack["version"])
}

func (c *current) onOptionalUnary1(op interface{}) (interface{}, error) {
	if op == nil {
		return "", nil
	}
	return op.(string), nil
}

func (p *parser) callonOptionalUnary1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOptionalUnary1(stack["op"])
}

func (c *current) onVersion1(head, tail interface{}) (interface{}, error) {
	log.Debug("👮 major", head)
	version := head.(string) + tail.(string)
	log.Debug("👮 whole version:", version)
	return version, nil
}

func (p *parser) callonVersion1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onVersion1(stack["head"], stack["tail"])
}

func (c *current) onOptionalMinorPatchPreRelease1(head, tail interface{}) (interface{}, error) {
	return head.(string) + tail.(string), nil
}

func (p *parser) callonOptionalMinorPatchPreRelease1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOptionalMinorPatchPreRelease1(stack["head"], stack["tail"])
}

func (c *current) onOptionalDotMinor1(minor interface{}) (interface{}, error) {
	if minor == nil {
		return ".0", nil
	}
	log.Debug("👮 minor", minor)
	return minor.(string), nil
}

func (p *parser) callonOptionalDotMinor1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOptionalDotMinor1(stack["minor"])
}

func (c *current) onOptionalPatchPreRelease1(head, tail interface{}) (interface{}, error) {
	if head == nil {
		return ".0" + tail.(string), nil
	}
	log.Debug("👮 patch", head)
	return head.(string) + tail.(string), nil

}

func (p *parser) callonOptionalPatchPreRelease1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOptionalPatchPreRelease1(stack["head"], stack["tail"])
}

func (c *current) onOptionalDotPatch1(patch interface{}) (interface{}, error) {
	if patch == nil {
		return ".0", nil
	}
	return patch.(string), nil
}

func (p *parser) callonOptionalDotPatch1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOptionalDotPatch1(stack["patch"])
}

func (c *current) onDotVersionPart1(n interface{}) (interface{}, error) {
	if n == nil {
		return ".0", nil
	}
	return "." + n.(string), nil
}

func (p *parser) callonDotVersionPart1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onDotVersionPart1(stack["n"])
}

func (c *current) onOptionalPreRelease1(prerelease interface{}) (interface{}, error) {
	if prerelease == nil {
		return "", nil
	}
	log.Debug("👮 prerelease", prerelease)
	if prerelease.(string) == "" {
		return "", nil
	}
	return "-" + prerelease.(string), nil
}

func (p *parser) callonOptionalPreRelease1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOptionalPreRelease1(stack["prerelease"])
}

func (c *current) onPreRelease1() (interface{}, error) {
	return string(c.text), nil
}

func (p *parser) callonPreRelease1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onPreRelease1()
}

func (c *current) onDot1() (interface{}, error) {
	return ".", nil
}

func (p *parser) callonDot1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onDot1()
}

func (c *current) onDash1() (interface{}, error) {
	return "-", nil
}

func (p *parser) callonDash1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onDash1()
}

func (c *current) onPlus1() (interface{}, error) {
	return "+", nil
}

func (p *parser) callonPlus1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onPlus1()
}

func (c *current) onWord1() (interface{}, error) {
	return string(c.text), nil
}

func (p *parser) callonWord1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onWord1()
}

func (c *current) onWildcard1(wildcard interface{}) (interface{}, error) {
	return string(wildcard.([]uint8)), nil
}

func (p *parser) callonWildcard1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onWildcard1(stack["wildcard"])
}

func (c *current) onNumber1() (interface{}, error) {
	var value = string(c.text)
	i, err := strconv.ParseInt(value, 10, 64)
	if err != nil {
		log.Print("Could not translate '", value, "' in 64bit int, will use original value")
		return value, nil
	}

	return strconv.FormatInt(i, 10), nil
}

func (p *parser) callonNumber1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onNumber1()
}

func (c *current) onComparator6() (interface{}, error) {
	log.Debug("👮 Comparator", c.text)
	return string(c.text), nil
}

func (p *parser) callonComparator6() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparator6()
}

func (c *current) onUnaryOperator1(op interface{}) (interface{}, error) {
	if op == nil {
		return "", nil
	}
	return string(op.([]uint8)), nil
}

func (p *parser) callonUnaryOperator1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onUnaryOperator1(stack["op"])
}

func (c *current) onMandatoryWhiteSpace1() (interface{}, error) {
	return string(" "), nil
}

func (p *parser) callonMandatoryWhiteSpace1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMandatoryWhiteSpace1()
}

var (
	// errNoRule is returned when the grammar to parse has no rule.
	errNoRule = errors.New("grammar has no rule")

	// errInvalidEntrypoint is returned when the specified entrypoint rule
	// does not exit.
	errInvalidEntrypoint = errors.New("invalid entrypoint")

	// errInvalidEncoding is returned when the source is not properly
	// utf8-encoded.
	errInvalidEncoding = errors.New("invalid encoding")

	// errMaxExprCnt is used to signal that the maximum number of
	// expressions have been parsed.
	errMaxExprCnt = errors.New("max number of expresssions parsed")
)

// Option is a function that can set an option on the parser. It returns
// the previous setting as an Option.
type Option func(*parser) Option

// MaxExpressions creates an Option to stop parsing after the provided
// number of expressions have been parsed, if the value is 0 then the parser will
// parse for as many steps as needed (possibly an infinite number).
//
// The default for maxExprCnt is 0.
func MaxExpressions(maxExprCnt uint64) Option {
	return func(p *parser) Option {
		oldMaxExprCnt := p.maxExprCnt
		p.maxExprCnt = maxExprCnt
		return MaxExpressions(oldMaxExprCnt)
	}
}

// Entrypoint creates an Option to set the rule name to use as entrypoint.
// The rule name must have been specified in the -alternate-entrypoints
// if generating the parser with the -optimize-grammar flag, otherwise
// it may have been optimized out. Passing an empty string sets the
// entrypoint to the first rule in the grammar.
//
// The default is to start parsing at the first rule in the grammar.
func Entrypoint(ruleName string) Option {
	return func(p *parser) Option {
		oldEntrypoint := p.entrypoint
		p.entrypoint = ruleName
		if ruleName == "" {
			p.entrypoint = g.rules[0].name
		}
		return Entrypoint(oldEntrypoint)
	}
}

// Statistics adds a user provided Stats struct to the parser to allow
// the user to process the results after the parsing has finished.
// Also the key for the "no match" counter is set.
//
// Example usage:
//
//     input := "input"
//     stats := Stats{}
//     _, err := Parse("input-file", []byte(input), Statistics(&stats, "no match"))
//     if err != nil {
//         log.Panicln(err)
//     }
//     b, err := json.MarshalIndent(stats.ChoiceAltCnt, "", "  ")
//     if err != nil {
//         log.Panicln(err)
//     }
//     fmt.Println(string(b))
//
func Statistics(stats *Stats, choiceNoMatch string) Option {
	return func(p *parser) Option {
		oldStats := p.Stats
		p.Stats = stats
		oldChoiceNoMatch := p.choiceNoMatch
		p.choiceNoMatch = choiceNoMatch
		if p.Stats.ChoiceAltCnt == nil {
			p.Stats.ChoiceAltCnt = make(map[string]map[string]int)
		}
		return Statistics(oldStats, oldChoiceNoMatch)
	}
}

// Debug creates an Option to set the debug flag to b. When set to true,
// debugging information is printed to stdout while parsing.
//
// The default is false.
func Debug(b bool) Option {
	return func(p *parser) Option {
		old := p.debug
		p.debug = b
		return Debug(old)
	}
}

// Memoize creates an Option to set the memoize flag to b. When set to true,
// the parser will cache all results so each expression is evaluated only
// once. This guarantees linear parsing time even for pathological cases,
// at the expense of more memory and slower times for typical cases.
//
// The default is false.
func Memoize(b bool) Option {
	return func(p *parser) Option {
		old := p.memoize
		p.memoize = b
		return Memoize(old)
	}
}

// AllowInvalidUTF8 creates an Option to allow invalid UTF-8 bytes.
// Every invalid UTF-8 byte is treated as a utf8.RuneError (U+FFFD)
// by character class matchers and is matched by the any matcher.
// The returned matched value, c.text and c.offset are NOT affected.
//
// The default is false.
func AllowInvalidUTF8(b bool) Option {
	return func(p *parser) Option {
		old := p.allowInvalidUTF8
		p.allowInvalidUTF8 = b
		return AllowInvalidUTF8(old)
	}
}

// Recover creates an Option to set the recover flag to b. When set to
// true, this causes the parser to recover from panics and convert it
// to an error. Setting it to false can be useful while debugging to
// access the full stack trace.
//
// The default is true.
func Recover(b bool) Option {
	return func(p *parser) Option {
		old := p.recover
		p.recover = b
		return Recover(old)
	}
}

// GlobalStore creates an Option to set a key to a certain value in
// the globalStore.
func GlobalStore(key string, value interface{}) Option {
	return func(p *parser) Option {
		old := p.cur.globalStore[key]
		p.cur.globalStore[key] = value
		return GlobalStore(key, old)
	}
}

// InitState creates an Option to set a key to a certain value in
// the global "state" store.
func InitState(key string, value interface{}) Option {
	return func(p *parser) Option {
		old := p.cur.state[key]
		p.cur.state[key] = value
		return InitState(key, old)
	}
}

// ParseFile parses the file identified by filename.
func ParseFile(filename string, opts ...Option) (i interface{}, err error) {
	f, err := os.Open(filename)
	if err != nil {
		return nil, err
	}
	defer func() {
		if closeErr := f.Close(); closeErr != nil {
			err = closeErr
		}
	}()
	return ParseReader(filename, f, opts...)
}

// ParseReader parses the data from r using filename as information in the
// error messages.
func ParseReader(filename string, r io.Reader, opts ...Option) (interface{}, error) {
	b, err := ioutil.ReadAll(r)
	if err != nil {
		return nil, err
	}

	return Parse(filename, b, opts...)
}

// Parse parses the data from b using filename as information in the
// error messages.
func Parse(filename string, b []byte, opts ...Option) (interface{}, error) {
	return newParser(filename, b, opts...).parse(g)
}

// position records a position in the text.
type position struct {
	line, col, offset int
}

func (p position) String() string {
	return fmt.Sprintf("%d:%d [%d]", p.line, p.col, p.offset)
}

// savepoint stores all state required to go back to this point in the
// parser.
type savepoint struct {
	position
	rn rune
	w  int
}

type current struct {
	pos  position // start position of the match
	text []byte   // raw text of the match

	// state is a store for arbitrary key,value pairs that the user wants to be
	// tied to the backtracking of the parser.
	// This is always rolled back if a parsing rule fails.
	state storeDict

	// globalStore is a general store for the user to store arbitrary key-value
	// pairs that they need to manage and that they do not want tied to the
	// backtracking of the parser. This is only modified by the user and never
	// rolled back by the parser. It is always up to the user to keep this in a
	// consistent state.
	globalStore storeDict
}

type storeDict map[string]interface{}

// the AST types...

type grammar struct {
	pos   position
	rules []*rule
}

type rule struct {
	pos         position
	name        string
	displayName string
	expr        interface{}
}

type choiceExpr struct {
	pos          position
	alternatives []interface{}
}

type actionExpr struct {
	pos  position
	expr interface{}
	run  func(*parser) (interface{}, error)
}

type recoveryExpr struct {
	pos          position
	expr         interface{}
	recoverExpr  interface{}
	failureLabel []string
}

type seqExpr struct {
	pos   position
	exprs []interface{}
}

type throwExpr struct {
	pos   position
	label string
}

type labeledExpr struct {
	pos   position
	label string
	expr  interface{}
}

type expr struct {
	pos  position
	expr interface{}
}

type andExpr expr
type notExpr expr
type zeroOrOneExpr expr
type zeroOrMoreExpr expr
type oneOrMoreExpr expr

type ruleRefExpr struct {
	pos  position
	name string
}

type stateCodeExpr struct {
	pos position
	run func(*parser) error
}

type andCodeExpr struct {
	pos position
	run func(*parser) (bool, error)
}

type notCodeExpr struct {
	pos position
	run func(*parser) (bool, error)
}

type litMatcher struct {
	pos        position
	val        string
	ignoreCase bool
}

type charClassMatcher struct {
	pos             position
	val             string
	basicLatinChars [128]bool
	chars           []rune
	ranges          []rune
	classes         []*unicode.RangeTable
	ignoreCase      bool
	inverted        bool
}

type anyMatcher position

// errList cumulates the errors found by the parser.
type errList []error

func (e *errList) add(err error) {
	*e = append(*e, err)
}

func (e errList) err() error {
	if len(e) == 0 {
		return nil
	}
	e.dedupe()
	return e
}

func (e *errList) dedupe() {
	var cleaned []error
	set := make(map[string]bool)
	for _, err := range *e {
		if msg := err.Error(); !set[msg] {
			set[msg] = true
			cleaned = append(cleaned, err)
		}
	}
	*e = cleaned
}

func (e errList) Error() string {
	switch len(e) {
	case 0:
		return ""
	case 1:
		return e[0].Error()
	default:
		var buf bytes.Buffer

		for i, err := range e {
			if i > 0 {
				buf.WriteRune('\n')
			}
			buf.WriteString(err.Error())
		}
		return buf.String()
	}
}

// parserError wraps an error with a prefix indicating the rule in which
// the error occurred. The original error is stored in the Inner field.
type parserError struct {
	Inner    error
	pos      position
	prefix   string
	expected []string
}

// Error returns the error message.
func (p *parserError) Error() string {
	return p.prefix + ": " + p.Inner.Error()
}

// newParser creates a parser with the specified input source and options.
func newParser(filename string, b []byte, opts ...Option) *parser {
	stats := Stats{
		ChoiceAltCnt: make(map[string]map[string]int),
	}

	p := &parser{
		filename: filename,
		errs:     new(errList),
		data:     b,
		pt:       savepoint{position: position{line: 1}},
		recover:  true,
		cur: current{
			state:       make(storeDict),
			globalStore: make(storeDict),
		},
		maxFailPos:      position{col: 1, line: 1},
		maxFailExpected: make([]string, 0, 20),
		Stats:           &stats,
		// start rule is rule [0] unless an alternate entrypoint is specified
		entrypoint: g.rules[0].name,
		emptyState: make(storeDict),
	}
	p.setOptions(opts)

	if p.maxExprCnt == 0 {
		p.maxExprCnt = math.MaxUint64
	}

	return p
}

// setOptions applies the options to the parser.
func (p *parser) setOptions(opts []Option) {
	for _, opt := range opts {
		opt(p)
	}
}

type resultTuple struct {
	v   interface{}
	b   bool
	end savepoint
}

const choiceNoMatch = -1

// Stats stores some statistics, gathered during parsing
type Stats struct {
	// ExprCnt counts the number of expressions processed during parsing
	// This value is compared to the maximum number of expressions allowed
	// (set by the MaxExpressions option).
	ExprCnt uint64

	// ChoiceAltCnt is used to count for each ordered choice expression,
	// which alternative is used how may times.
	// These numbers allow to optimize the order of the ordered choice expression
	// to increase the performance of the parser
	//
	// The outer key of ChoiceAltCnt is composed of the name of the rule as well
	// as the line and the column of the ordered choice.
	// The inner key of ChoiceAltCnt is the number (one-based) of the matching alternative.
	// For each alternative the number of matches are counted. If an ordered choice does not
	// match, a special counter is incremented. The name of this counter is set with
	// the parser option Statistics.
	// For an alternative to be included in ChoiceAltCnt, it has to match at least once.
	ChoiceAltCnt map[string]map[string]int
}

type parser struct {
	filename string
	pt       savepoint
	cur      current

	data []byte
	errs *errList

	depth   int
	recover bool
	debug   bool

	memoize bool
	// memoization table for the packrat algorithm:
	// map[offset in source] map[expression or rule] {value, match}
	memo map[int]map[interface{}]resultTuple

	// rules table, maps the rule identifier to the rule node
	rules map[string]*rule
	// variables stack, map of label to value
	vstack []map[string]interface{}
	// rule stack, allows identification of the current rule in errors
	rstack []*rule

	// parse fail
	maxFailPos            position
	maxFailExpected       []string
	maxFailInvertExpected bool

	// max number of expressions to be parsed
	maxExprCnt uint64
	// entrypoint for the parser
	entrypoint string

	allowInvalidUTF8 bool

	*Stats

	choiceNoMatch string
	// recovery expression stack, keeps track of the currently available recovery expression, these are traversed in reverse
	recoveryStack []map[string]interface{}

	// emptyState contains an empty storeDict, which is used to optimize cloneState if global "state" store is not used.
	emptyState storeDict
}

// push a variable set on the vstack.
func (p *parser) pushV() {
	if cap(p.vstack) == len(p.vstack) {
		// create new empty slot in the stack
		p.vstack = append(p.vstack, nil)
	} else {
		// slice to 1 more
		p.vstack = p.vstack[:len(p.vstack)+1]
	}

	// get the last args set
	m := p.vstack[len(p.vstack)-1]
	if m != nil && len(m) == 0 {
		// empty map, all good
		return
	}

	m = make(map[string]interface{})
	p.vstack[len(p.vstack)-1] = m
}

// pop a variable set from the vstack.
func (p *parser) popV() {
	// if the map is not empty, clear it
	m := p.vstack[len(p.vstack)-1]
	if len(m) > 0 {
		// GC that map
		p.vstack[len(p.vstack)-1] = nil
	}
	p.vstack = p.vstack[:len(p.vstack)-1]
}

// push a recovery expression with its labels to the recoveryStack
func (p *parser) pushRecovery(labels []string, expr interface{}) {
	if cap(p.recoveryStack) == len(p.recoveryStack) {
		// create new empty slot in the stack
		p.recoveryStack = append(p.recoveryStack, nil)
	} else {
		// slice to 1 more
		p.recoveryStack = p.recoveryStack[:len(p.recoveryStack)+1]
	}

	m := make(map[string]interface{}, len(labels))
	for _, fl := range labels {
		m[fl] = expr
	}
	p.recoveryStack[len(p.recoveryStack)-1] = m
}

// pop a recovery expression from the recoveryStack
func (p *parser) popRecovery() {
	// GC that map
	p.recoveryStack[len(p.recoveryStack)-1] = nil

	p.recoveryStack = p.recoveryStack[:len(p.recoveryStack)-1]
}

func (p *parser) print(prefix, s string) string {
	if !p.debug {
		return s
	}

	fmt.Printf("%s %d:%d:%d: %s [%#U]\n",
		prefix, p.pt.line, p.pt.col, p.pt.offset, s, p.pt.rn)
	return s
}

func (p *parser) in(s string) string {
	p.depth++
	return p.print(strings.Repeat(" ", p.depth)+">", s)
}

func (p *parser) out(s string) string {
	p.depth--
	return p.print(strings.Repeat(" ", p.depth)+"<", s)
}

func (p *parser) addErr(err error) {
	p.addErrAt(err, p.pt.position, []string{})
}

func (p *parser) addErrAt(err error, pos position, expected []string) {
	var buf bytes.Buffer
	if p.filename != "" {
		buf.WriteString(p.filename)
	}
	if buf.Len() > 0 {
		buf.WriteString(":")
	}
	buf.WriteString(fmt.Sprintf("%d:%d (%d)", pos.line, pos.col, pos.offset))
	if len(p.rstack) > 0 {
		if buf.Len() > 0 {
			buf.WriteString(": ")
		}
		rule := p.rstack[len(p.rstack)-1]
		if rule.displayName != "" {
			buf.WriteString("rule " + rule.displayName)
		} else {
			buf.WriteString("rule " + rule.name)
		}
	}
	pe := &parserError{Inner: err, pos: pos, prefix: buf.String(), expected: expected}
	p.errs.add(pe)
}

func (p *parser) failAt(fail bool, pos position, want string) {
	// process fail if parsing fails and not inverted or parsing succeeds and invert is set
	if fail == p.maxFailInvertExpected {
		if pos.offset < p.maxFailPos.offset {
			return
		}

		if pos.offset > p.maxFailPos.offset {
			p.maxFailPos = pos
			p.maxFailExpected = p.maxFailExpected[:0]
		}

		if p.maxFailInvertExpected {
			want = "!" + want
		}
		p.maxFailExpected = append(p.maxFailExpected, want)
	}
}

// read advances the parser to the next rune.
func (p *parser) read() {
	p.pt.offset += p.pt.w
	rn, n := utf8.DecodeRune(p.data[p.pt.offset:])
	p.pt.rn = rn
	p.pt.w = n
	p.pt.col++
	if rn == '\n' {
		p.pt.line++
		p.pt.col = 0
	}

	if rn == utf8.RuneError && n == 1 { // see utf8.DecodeRune
		if !p.allowInvalidUTF8 {
			p.addErr(errInvalidEncoding)
		}
	}
}

// restore parser position to the savepoint pt.
func (p *parser) restore(pt savepoint) {
	if p.debug {
		defer p.out(p.in("restore"))
	}
	if pt.offset == p.pt.offset {
		return
	}
	p.pt = pt
}

// Cloner is implemented by any value that has a Clone method, which returns a
// copy of the value. This is mainly used for types which are not passed by
// value (e.g map, slice, chan) or structs that contain such types.
//
// This is used in conjunction with the global state feature to create proper
// copies of the state to allow the parser to properly restore the state in
// the case of backtracking.
type Cloner interface {
	Clone() interface{}
}

// clone and return parser current state.
func (p *parser) cloneState() storeDict {
	if p.debug {
		defer p.out(p.in("cloneState"))
	}

	if len(p.cur.state) == 0 {
		if len(p.emptyState) > 0 {
			p.emptyState = make(storeDict)
		}
		return p.emptyState
	}

	state := make(storeDict, len(p.cur.state))
	for k, v := range p.cur.state {
		if c, ok := v.(Cloner); ok {
			state[k] = c.Clone()
		} else {
			state[k] = v
		}
	}
	return state
}

// restore parser current state to the state storeDict.
// every restoreState should applied only one time for every cloned state
func (p *parser) restoreState(state storeDict) {
	if p.debug {
		defer p.out(p.in("restoreState"))
	}
	p.cur.state = state
}

// get the slice of bytes from the savepoint start to the current position.
func (p *parser) sliceFrom(start savepoint) []byte {
	return p.data[start.position.offset:p.pt.position.offset]
}

func (p *parser) getMemoized(node interface{}) (resultTuple, bool) {
	if len(p.memo) == 0 {
		return resultTuple{}, false
	}
	m := p.memo[p.pt.offset]
	if len(m) == 0 {
		return resultTuple{}, false
	}
	res, ok := m[node]
	return res, ok
}

func (p *parser) setMemoized(pt savepoint, node interface{}, tuple resultTuple) {
	if p.memo == nil {
		p.memo = make(map[int]map[interface{}]resultTuple)
	}
	m := p.memo[pt.offset]
	if m == nil {
		m = make(map[interface{}]resultTuple)
		p.memo[pt.offset] = m
	}
	m[node] = tuple
}

func (p *parser) buildRulesTable(g *grammar) {
	p.rules = make(map[string]*rule, len(g.rules))
	for _, r := range g.rules {
		p.rules[r.name] = r
	}
}

func (p *parser) parse(g *grammar) (val interface{}, err error) {
	if len(g.rules) == 0 {
		p.addErr(errNoRule)
		return nil, p.errs.err()
	}

	// TODO : not super critical but this could be generated
	p.buildRulesTable(g)

	if p.recover {
		// panic can be used in action code to stop parsing immediately
		// and return the panic as an error.
		defer func() {
			if e := recover(); e != nil {
				if p.debug {
					defer p.out(p.in("panic handler"))
				}
				val = nil
				switch e := e.(type) {
				case error:
					p.addErr(e)
				default:
					p.addErr(fmt.Errorf("%v", e))
				}
				err = p.errs.err()
			}
		}()
	}

	startRule, ok := p.rules[p.entrypoint]
	if !ok {
		p.addErr(errInvalidEntrypoint)
		return nil, p.errs.err()
	}

	p.read() // advance to first rune
	val, ok = p.parseRule(startRule)
	if !ok {
		if len(*p.errs) == 0 {
			// If parsing fails, but no errors have been recorded, the expected values
			// for the farthest parser position are returned as error.
			maxFailExpectedMap := make(map[string]struct{}, len(p.maxFailExpected))
			for _, v := range p.maxFailExpected {
				maxFailExpectedMap[v] = struct{}{}
			}
			expected := make([]string, 0, len(maxFailExpectedMap))
			eof := false
			if _, ok := maxFailExpectedMap["!."]; ok {
				delete(maxFailExpectedMap, "!.")
				eof = true
			}
			for k := range maxFailExpectedMap {
				expected = append(expected, k)
			}
			sort.Strings(expected)
			if eof {
				expected = append(expected, "EOF")
			}
			p.addErrAt(errors.New("no match found, expected: "+listJoin(expected, ", ", "or")), p.maxFailPos, expected)
		}

		return nil, p.errs.err()
	}
	return val, p.errs.err()
}

func listJoin(list []string, sep string, lastSep string) string {
	switch len(list) {
	case 0:
		return ""
	case 1:
		return list[0]
	default:
		return fmt.Sprintf("%s %s %s", strings.Join(list[:len(list)-1], sep), lastSep, list[len(list)-1])
	}
}

func (p *parser) parseRule(rule *rule) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseRule " + rule.name))
	}

	if p.memoize {
		res, ok := p.getMemoized(rule)
		if ok {
			p.restore(res.end)
			return res.v, res.b
		}
	}

	start := p.pt
	p.rstack = append(p.rstack, rule)
	p.pushV()
	val, ok := p.parseExpr(rule.expr)
	p.popV()
	p.rstack = p.rstack[:len(p.rstack)-1]
	if ok && p.debug {
		p.print(strings.Repeat(" ", p.depth)+"MATCH", string(p.sliceFrom(start)))
	}

	if p.memoize {
		p.setMemoized(start, rule, resultTuple{val, ok, p.pt})
	}
	return val, ok
}

func (p *parser) parseExpr(expr interface{}) (interface{}, bool) {
	var pt savepoint

	if p.memoize {
		res, ok := p.getMemoized(expr)
		if ok {
			p.restore(res.end)
			return res.v, res.b
		}
		pt = p.pt
	}

	p.ExprCnt++
	if p.ExprCnt > p.maxExprCnt {
		panic(errMaxExprCnt)
	}

	var val interface{}
	var ok bool
	switch expr := expr.(type) {
	case *actionExpr:
		val, ok = p.parseActionExpr(expr)
	case *andCodeExpr:
		val, ok = p.parseAndCodeExpr(expr)
	case *andExpr:
		val, ok = p.parseAndExpr(expr)
	case *anyMatcher:
		val, ok = p.parseAnyMatcher(expr)
	case *charClassMatcher:
		val, ok = p.parseCharClassMatcher(expr)
	case *choiceExpr:
		val, ok = p.parseChoiceExpr(expr)
	case *labeledExpr:
		val, ok = p.parseLabeledExpr(expr)
	case *litMatcher:
		val, ok = p.parseLitMatcher(expr)
	case *notCodeExpr:
		val, ok = p.parseNotCodeExpr(expr)
	case *notExpr:
		val, ok = p.parseNotExpr(expr)
	case *oneOrMoreExpr:
		val, ok = p.parseOneOrMoreExpr(expr)
	case *recoveryExpr:
		val, ok = p.parseRecoveryExpr(expr)
	case *ruleRefExpr:
		val, ok = p.parseRuleRefExpr(expr)
	case *seqExpr:
		val, ok = p.parseSeqExpr(expr)
	case *stateCodeExpr:
		val, ok = p.parseStateCodeExpr(expr)
	case *throwExpr:
		val, ok = p.parseThrowExpr(expr)
	case *zeroOrMoreExpr:
		val, ok = p.parseZeroOrMoreExpr(expr)
	case *zeroOrOneExpr:
		val, ok = p.parseZeroOrOneExpr(expr)
	default:
		panic(fmt.Sprintf("unknown expression type %T", expr))
	}
	if p.memoize {
		p.setMemoized(pt, expr, resultTuple{val, ok, p.pt})
	}
	return val, ok
}

func (p *parser) parseActionExpr(act *actionExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseActionExpr"))
	}

	start := p.pt
	val, ok := p.parseExpr(act.expr)
	if ok {
		p.cur.pos = start.position
		p.cur.text = p.sliceFrom(start)
		state := p.cloneState()
		actVal, err := act.run(p)
		if err != nil {
			p.addErrAt(err, start.position, []string{})
		}
		p.restoreState(state)

		val = actVal
	}
	if ok && p.debug {
		p.print(strings.Repeat(" ", p.depth)+"MATCH", string(p.sliceFrom(start)))
	}
	return val, ok
}

func (p *parser) parseAndCodeExpr(and *andCodeExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseAndCodeExpr"))
	}

	state := p.cloneState()

	ok, err := and.run(p)
	if err != nil {
		p.addErr(err)
	}
	p.restoreState(state)

	return nil, ok
}

func (p *parser) parseAndExpr(and *andExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseAndExpr"))
	}

	pt := p.pt
	state := p.cloneState()
	p.pushV()
	_, ok := p.parseExpr(and.expr)
	p.popV()
	p.restoreState(state)
	p.restore(pt)

	return nil, ok
}

func (p *parser) parseAnyMatcher(any *anyMatcher) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseAnyMatcher"))
	}

	if p.pt.rn == utf8.RuneError && p.pt.w == 0 {
		// EOF - see utf8.DecodeRune
		p.failAt(false, p.pt.position, ".")
		return nil, false
	}
	start := p.pt
	p.read()
	p.failAt(true, start.position, ".")
	return p.sliceFrom(start), true
}

func (p *parser) parseCharClassMatcher(chr *charClassMatcher) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseCharClassMatcher"))
	}

	cur := p.pt.rn
	start := p.pt

	// can't match EOF
	if cur == utf8.RuneError && p.pt.w == 0 { // see utf8.DecodeRune
		p.failAt(false, start.position, chr.val)
		return nil, false
	}

	if chr.ignoreCase {
		cur = unicode.ToLower(cur)
	}

	// try to match in the list of available chars
	for _, rn := range chr.chars {
		if rn == cur {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	// try to match in the list of ranges
	for i := 0; i < len(chr.ranges); i += 2 {
		if cur >= chr.ranges[i] && cur <= chr.ranges[i+1] {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	// try to match in the list of Unicode classes
	for _, cl := range chr.classes {
		if unicode.Is(cl, cur) {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	if chr.inverted {
		p.read()
		p.failAt(true, start.position, chr.val)
		return p.sliceFrom(start), true
	}
	p.failAt(false, start.position, chr.val)
	return nil, false
}

func (p *parser) incChoiceAltCnt(ch *choiceExpr, altI int) {
	choiceIdent := fmt.Sprintf("%s %d:%d", p.rstack[len(p.rstack)-1].name, ch.pos.line, ch.pos.col)
	m := p.ChoiceAltCnt[choiceIdent]
	if m == nil {
		m = make(map[string]int)
		p.ChoiceAltCnt[choiceIdent] = m
	}
	// We increment altI by 1, so the keys do not start at 0
	alt := strconv.Itoa(altI + 1)
	if altI == choiceNoMatch {
		alt = p.choiceNoMatch
	}
	m[alt]++
}

func (p *parser) parseChoiceExpr(ch *choiceExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseChoiceExpr"))
	}

	for altI, alt := range ch.alternatives {
		// dummy assignment to prevent compile error if optimized
		_ = altI

		state := p.cloneState()

		p.pushV()
		val, ok := p.parseExpr(alt)
		p.popV()
		if ok {
			p.incChoiceAltCnt(ch, altI)
			return val, ok
		}
		p.restoreState(state)
	}
	p.incChoiceAltCnt(ch, choiceNoMatch)
	return nil, false
}

func (p *parser) parseLabeledExpr(lab *labeledExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseLabeledExpr"))
	}

	p.pushV()
	val, ok := p.parseExpr(lab.expr)
	p.popV()
	if ok && lab.label != "" {
		m := p.vstack[len(p.vstack)-1]
		m[lab.label] = val
	}
	return val, ok
}

func (p *parser) parseLitMatcher(lit *litMatcher) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseLitMatcher"))
	}

	ignoreCase := ""
	if lit.ignoreCase {
		ignoreCase = "i"
	}
	val := fmt.Sprintf("%q%s", lit.val, ignoreCase)
	start := p.pt
	for _, want := range lit.val {
		cur := p.pt.rn
		if lit.ignoreCase {
			cur = unicode.ToLower(cur)
		}
		if cur != want {
			p.failAt(false, start.position, val)
			p.restore(start)
			return nil, false
		}
		p.read()
	}
	p.failAt(true, start.position, val)
	return p.sliceFrom(start), true
}

func (p *parser) parseNotCodeExpr(not *notCodeExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseNotCodeExpr"))
	}

	state := p.cloneState()

	ok, err := not.run(p)
	if err != nil {
		p.addErr(err)
	}
	p.restoreState(state)

	return nil, !ok
}

func (p *parser) parseNotExpr(not *notExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseNotExpr"))
	}

	pt := p.pt
	state := p.cloneState()
	p.pushV()
	p.maxFailInvertExpected = !p.maxFailInvertExpected
	_, ok := p.parseExpr(not.expr)
	p.maxFailInvertExpected = !p.maxFailInvertExpected
	p.popV()
	p.restoreState(state)
	p.restore(pt)

	return nil, !ok
}

func (p *parser) parseOneOrMoreExpr(expr *oneOrMoreExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseOneOrMoreExpr"))
	}

	var vals []interface{}

	for {
		p.pushV()
		val, ok := p.parseExpr(expr.expr)
		p.popV()
		if !ok {
			if len(vals) == 0 {
				// did not match once, no match
				return nil, false
			}
			return vals, true
		}
		vals = append(vals, val)
	}
}

func (p *parser) parseRecoveryExpr(recover *recoveryExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseRecoveryExpr (" + strings.Join(recover.failureLabel, ",") + ")"))
	}

	p.pushRecovery(recover.failureLabel, recover.recoverExpr)
	val, ok := p.parseExpr(recover.expr)
	p.popRecovery()

	return val, ok
}

func (p *parser) parseRuleRefExpr(ref *ruleRefExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseRuleRefExpr " + ref.name))
	}

	if ref.name == "" {
		panic(fmt.Sprintf("%s: invalid rule: missing name", ref.pos))
	}

	rule := p.rules[ref.name]
	if rule == nil {
		p.addErr(fmt.Errorf("undefined rule: %s", ref.name))
		return nil, false
	}
	return p.parseRule(rule)
}

func (p *parser) parseSeqExpr(seq *seqExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseSeqExpr"))
	}

	vals := make([]interface{}, 0, len(seq.exprs))

	pt := p.pt
	state := p.cloneState()
	for _, expr := range seq.exprs {
		val, ok := p.parseExpr(expr)
		if !ok {
			p.restoreState(state)
			p.restore(pt)
			return nil, false
		}
		vals = append(vals, val)
	}
	return vals, true
}

func (p *parser) parseStateCodeExpr(state *stateCodeExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseStateCodeExpr"))
	}

	err := state.run(p)
	if err != nil {
		p.addErr(err)
	}
	return nil, true
}

func (p *parser) parseThrowExpr(expr *throwExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseThrowExpr"))
	}

	for i := len(p.recoveryStack) - 1; i >= 0; i-- {
		if recoverExpr, ok := p.recoveryStack[i][expr.label]; ok {
			if val, ok := p.parseExpr(recoverExpr); ok {
				return val, ok
			}
		}
	}

	return nil, false
}

func (p *parser) parseZeroOrMoreExpr(expr *zeroOrMoreExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseZeroOrMoreExpr"))
	}

	var vals []interface{}

	for {
		p.pushV()
		val, ok := p.parseExpr(expr.expr)
		p.popV()
		if !ok {
			return vals, true
		}
		vals = append(vals, val)
	}
}

func (p *parser) parseZeroOrOneExpr(expr *zeroOrOneExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseZeroOrOneExpr"))
	}

	p.pushV()
	val, _ := p.parseExpr(expr.expr)
	p.popV()
	// whether it matched or not, consider it a match
	return val, true
}
