// Code generated by pigeon; DO NOT EDIT.

// yarn.lock parser
package yarnlockparser

import (
	"bytes"
	"errors"
	"fmt"
	"io"
	"io/ioutil"
	"math"
	"os"
	"sort"
	"strconv"
	"strings"
	"unicode"
	"unicode/utf8"

	"github.com/nearform/gammaray/nodepackage"
	log "github.com/sirupsen/logrus"
)

func ParseYarnLock(expression string, opts ...Option) ([]nodepackage.NodePackage, error) {
	got, err := ParseReader("yarn.lock", strings.NewReader(expression), opts...)
	if err != nil {
		log.Error("👽 In :\n"+expression+"<<EOF>>\n-->", err)
		return nil, err
	}
	log.Debug("👽 In :\n"+expression+"<<EOF>>\n-->", got)
	return got.([]nodepackage.NodePackage), err
}

func toIfaceSlice(v interface{}) []interface{} {
	if v == nil {
		return nil
	}
	return v.([]interface{})
}

var g = &grammar{
	rules: []*rule{
		{
			name: "Input",
			pos:  position{line: 29, col: 1, offset: 642},
			expr: &actionExpr{
				pos: position{line: 29, col: 9, offset: 650},
				run: (*parser).callonInput1,
				expr: &seqExpr{
					pos: position{line: 29, col: 9, offset: 650},
					exprs: []interface{}{
						&ruleRefExpr{
							pos:  position{line: 29, col: 9, offset: 650},
							name: "Header",
						},
						&labeledExpr{
							pos:   position{line: 29, col: 16, offset: 657},
							label: "deps",
							expr: &ruleRefExpr{
								pos:  position{line: 29, col: 21, offset: 662},
								name: "Body",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 29, col: 26, offset: 667},
							name: "EOF",
						},
					},
				},
			},
		},
		{
			name: "Header",
			pos:  position{line: 33, col: 1, offset: 723},
			expr: &seqExpr{
				pos: position{line: 33, col: 10, offset: 732},
				exprs: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 33, col: 10, offset: 732},
						name: "CommentLine",
					},
					&ruleRefExpr{
						pos:  position{line: 33, col: 22, offset: 744},
						name: "YarnLockfileVersionLine",
					},
				},
			},
		},
		{
			name: "Body",
			pos:  position{line: 35, col: 1, offset: 769},
			expr: &actionExpr{
				pos: position{line: 35, col: 8, offset: 776},
				run: (*parser).callonBody1,
				expr: &seqExpr{
					pos: position{line: 35, col: 8, offset: 776},
					exprs: []interface{}{
						&zeroOrMoreExpr{
							pos: position{line: 35, col: 8, offset: 776},
							expr: &ruleRefExpr{
								pos:  position{line: 35, col: 8, offset: 776},
								name: "LCNM",
							},
						},
						&labeledExpr{
							pos:   position{line: 35, col: 14, offset: 782},
							label: "deps",
							expr: &zeroOrMoreExpr{
								pos: position{line: 35, col: 20, offset: 788},
								expr: &ruleRefExpr{
									pos:  position{line: 35, col: 20, offset: 788},
									name: "Dependency",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "Dependency",
			pos:  position{line: 46, col: 1, offset: 1040},
			expr: &actionExpr{
				pos: position{line: 46, col: 14, offset: 1053},
				run: (*parser).callonDependency1,
				expr: &seqExpr{
					pos: position{line: 46, col: 15, offset: 1054},
					exprs: []interface{}{
						&labeledExpr{
							pos:   position{line: 46, col: 15, offset: 1054},
							label: "name",
							expr: &ruleRefExpr{
								pos:  position{line: 46, col: 20, offset: 1059},
								name: "DependencyHeaderLine",
							},
						},
						&labeledExpr{
							pos:   position{line: 46, col: 41, offset: 1080},
							label: "version",
							expr: &ruleRefExpr{
								pos:  position{line: 46, col: 49, offset: 1088},
								name: "DependencyVersionLine",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 46, col: 71, offset: 1110},
							name: "DependencyResolvedLine",
						},
						&zeroOrOneExpr{
							pos: position{line: 46, col: 94, offset: 1133},
							expr: &seqExpr{
								pos: position{line: 46, col: 95, offset: 1134},
								exprs: []interface{}{
									&ruleRefExpr{
										pos:  position{line: 46, col: 95, offset: 1134},
										name: "DependencyDependenciesHeaderLine",
									},
									&zeroOrMoreExpr{
										pos: position{line: 46, col: 128, offset: 1167},
										expr: &ruleRefExpr{
											pos:  position{line: 46, col: 128, offset: 1167},
											name: "DependencyDependency",
										},
									},
								},
							},
						},
						&zeroOrOneExpr{
							pos: position{line: 46, col: 152, offset: 1191},
							expr: &seqExpr{
								pos: position{line: 46, col: 153, offset: 1192},
								exprs: []interface{}{
									&ruleRefExpr{
										pos:  position{line: 46, col: 153, offset: 1192},
										name: "DependencyOptionalDependenciesHeaderLine",
									},
									&zeroOrMoreExpr{
										pos: position{line: 46, col: 194, offset: 1233},
										expr: &ruleRefExpr{
											pos:  position{line: 46, col: 194, offset: 1233},
											name: "DependencyOptionalDependency",
										},
									},
								},
							},
						},
						&zeroOrMoreExpr{
							pos: position{line: 46, col: 226, offset: 1265},
							expr: &ruleRefExpr{
								pos:  position{line: 46, col: 226, offset: 1265},
								name: "LCNM",
							},
						},
					},
				},
			},
		},
		{
			name: "DependencyHeaderLine",
			pos:  position{line: 52, col: 1, offset: 1435},
			expr: &actionExpr{
				pos: position{line: 52, col: 24, offset: 1458},
				run: (*parser).callonDependencyHeaderLine1,
				expr: &seqExpr{
					pos: position{line: 52, col: 25, offset: 1459},
					exprs: []interface{}{
						&labeledExpr{
							pos:   position{line: 52, col: 25, offset: 1459},
							label: "name",
							expr: &ruleRefExpr{
								pos:  position{line: 52, col: 30, offset: 1464},
								name: "ListOfPackageQueryExpression",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 52, col: 59, offset: 1493},
							name: "Colon",
						},
						&ruleRefExpr{
							pos:  position{line: 52, col: 65, offset: 1499},
							name: "ROL",
						},
					},
				},
			},
		},
		{
			name: "DependencyVersionLine",
			pos:  position{line: 56, col: 1, offset: 1605},
			expr: &actionExpr{
				pos: position{line: 56, col: 25, offset: 1629},
				run: (*parser).callonDependencyVersionLine1,
				expr: &seqExpr{
					pos: position{line: 56, col: 26, offset: 1630},
					exprs: []interface{}{
						&ruleRefExpr{
							pos:  position{line: 56, col: 26, offset: 1630},
							name: "__",
						},
						&litMatcher{
							pos:        position{line: 56, col: 29, offset: 1633},
							val:        "version",
							ignoreCase: false,
						},
						&oneOrMoreExpr{
							pos: position{line: 56, col: 39, offset: 1643},
							expr: &ruleRefExpr{
								pos:  position{line: 56, col: 39, offset: 1643},
								name: "_",
							},
						},
						&labeledExpr{
							pos:   position{line: 56, col: 42, offset: 1646},
							label: "version",
							expr: &ruleRefExpr{
								pos:  position{line: 56, col: 50, offset: 1654},
								name: "VersionExpression",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 56, col: 68, offset: 1672},
							name: "ROL",
						},
					},
				},
			},
		},
		{
			name: "DependencyResolvedLine",
			pos:  position{line: 60, col: 1, offset: 1785},
			expr: &seqExpr{
				pos: position{line: 60, col: 26, offset: 1810},
				exprs: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 60, col: 26, offset: 1810},
						name: "__",
					},
					&litMatcher{
						pos:        position{line: 60, col: 29, offset: 1813},
						val:        "resolved",
						ignoreCase: false,
					},
					&ruleRefExpr{
						pos:  position{line: 60, col: 40, offset: 1824},
						name: "IgnoredRestOfLine",
					},
				},
			},
		},
		{
			name: "DependencyDependenciesHeaderLine",
			pos:  position{line: 61, col: 1, offset: 1842},
			expr: &seqExpr{
				pos: position{line: 61, col: 36, offset: 1877},
				exprs: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 61, col: 36, offset: 1877},
						name: "__",
					},
					&litMatcher{
						pos:        position{line: 61, col: 39, offset: 1880},
						val:        "dependencies",
						ignoreCase: false,
					},
					&zeroOrMoreExpr{
						pos: position{line: 61, col: 54, offset: 1895},
						expr: &ruleRefExpr{
							pos:  position{line: 61, col: 54, offset: 1895},
							name: "_",
						},
					},
					&ruleRefExpr{
						pos:  position{line: 61, col: 57, offset: 1898},
						name: "Colon",
					},
					&ruleRefExpr{
						pos:  position{line: 61, col: 63, offset: 1904},
						name: "ROL",
					},
				},
			},
		},
		{
			name: "DependencyDependency",
			pos:  position{line: 62, col: 1, offset: 1908},
			expr: &seqExpr{
				pos: position{line: 62, col: 24, offset: 1931},
				exprs: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 62, col: 24, offset: 1931},
						name: "____",
					},
					&ruleRefExpr{
						pos:  position{line: 62, col: 29, offset: 1936},
						name: "PackageNameExpression",
					},
					&oneOrMoreExpr{
						pos: position{line: 62, col: 51, offset: 1958},
						expr: &ruleRefExpr{
							pos:  position{line: 62, col: 51, offset: 1958},
							name: "_",
						},
					},
					&ruleRefExpr{
						pos:  position{line: 62, col: 54, offset: 1961},
						name: "VersionQueryExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 62, col: 77, offset: 1984},
						name: "ROL",
					},
				},
			},
		},
		{
			name: "DependencyOptionalDependenciesHeaderLine",
			pos:  position{line: 63, col: 1, offset: 1988},
			expr: &seqExpr{
				pos: position{line: 63, col: 44, offset: 2031},
				exprs: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 63, col: 44, offset: 2031},
						name: "__",
					},
					&litMatcher{
						pos:        position{line: 63, col: 47, offset: 2034},
						val:        "optionalDependencies",
						ignoreCase: false,
					},
					&zeroOrMoreExpr{
						pos: position{line: 63, col: 70, offset: 2057},
						expr: &ruleRefExpr{
							pos:  position{line: 63, col: 70, offset: 2057},
							name: "_",
						},
					},
					&ruleRefExpr{
						pos:  position{line: 63, col: 73, offset: 2060},
						name: "Colon",
					},
					&ruleRefExpr{
						pos:  position{line: 63, col: 79, offset: 2066},
						name: "ROL",
					},
				},
			},
		},
		{
			name: "DependencyOptionalDependency",
			pos:  position{line: 64, col: 1, offset: 2070},
			expr: &seqExpr{
				pos: position{line: 64, col: 32, offset: 2101},
				exprs: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 64, col: 32, offset: 2101},
						name: "____",
					},
					&ruleRefExpr{
						pos:  position{line: 64, col: 37, offset: 2106},
						name: "PackageNameExpression",
					},
					&oneOrMoreExpr{
						pos: position{line: 64, col: 59, offset: 2128},
						expr: &ruleRefExpr{
							pos:  position{line: 64, col: 59, offset: 2128},
							name: "_",
						},
					},
					&ruleRefExpr{
						pos:  position{line: 64, col: 62, offset: 2131},
						name: "VersionQueryExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 64, col: 85, offset: 2154},
						name: "ROL",
					},
				},
			},
		},
		{
			name: "ListOfPackageQueryExpression",
			pos:  position{line: 66, col: 1, offset: 2159},
			expr: &actionExpr{
				pos: position{line: 66, col: 32, offset: 2190},
				run: (*parser).callonListOfPackageQueryExpression1,
				expr: &seqExpr{
					pos: position{line: 66, col: 32, offset: 2190},
					exprs: []interface{}{
						&labeledExpr{
							pos:   position{line: 66, col: 32, offset: 2190},
							label: "name",
							expr: &ruleRefExpr{
								pos:  position{line: 66, col: 37, offset: 2195},
								name: "PackageQueryExpression",
							},
						},
						&zeroOrMoreExpr{
							pos: position{line: 66, col: 61, offset: 2219},
							expr: &seqExpr{
								pos: position{line: 66, col: 62, offset: 2220},
								exprs: []interface{}{
									&zeroOrMoreExpr{
										pos: position{line: 66, col: 62, offset: 2220},
										expr: &ruleRefExpr{
											pos:  position{line: 66, col: 62, offset: 2220},
											name: "_",
										},
									},
									&ruleRefExpr{
										pos:  position{line: 66, col: 65, offset: 2223},
										name: "Comma",
									},
									&zeroOrMoreExpr{
										pos: position{line: 66, col: 71, offset: 2229},
										expr: &ruleRefExpr{
											pos:  position{line: 66, col: 71, offset: 2229},
											name: "_",
										},
									},
									&ruleRefExpr{
										pos:  position{line: 66, col: 74, offset: 2232},
										name: "PackageQueryExpression",
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "PackageQueryExpression",
			pos:  position{line: 70, col: 1, offset: 2366},
			expr: &actionExpr{
				pos: position{line: 70, col: 26, offset: 2391},
				run: (*parser).callonPackageQueryExpression1,
				expr: &labeledExpr{
					pos:   position{line: 70, col: 26, offset: 2391},
					label: "name",
					expr: &choiceExpr{
						pos: position{line: 70, col: 32, offset: 2397},
						alternatives: []interface{}{
							&ruleRefExpr{
								pos:  position{line: 70, col: 32, offset: 2397},
								name: "QuotedPackageQuery",
							},
							&ruleRefExpr{
								pos:  position{line: 70, col: 53, offset: 2418},
								name: "PackageQuery",
							},
						},
					},
				},
			},
		},
		{
			name: "QuotedPackageQuery",
			pos:  position{line: 75, col: 1, offset: 2525},
			expr: &actionExpr{
				pos: position{line: 75, col: 22, offset: 2546},
				run: (*parser).callonQuotedPackageQuery1,
				expr: &seqExpr{
					pos: position{line: 75, col: 23, offset: 2547},
					exprs: []interface{}{
						&ruleRefExpr{
							pos:  position{line: 75, col: 23, offset: 2547},
							name: "Quote",
						},
						&labeledExpr{
							pos:   position{line: 75, col: 29, offset: 2553},
							label: "name",
							expr: &ruleRefExpr{
								pos:  position{line: 75, col: 34, offset: 2558},
								name: "PackageName",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 75, col: 46, offset: 2570},
							name: "Arobase",
						},
						&oneOrMoreExpr{
							pos: position{line: 75, col: 54, offset: 2578},
							expr: &ruleRefExpr{
								pos:  position{line: 75, col: 54, offset: 2578},
								name: "NotQuote",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 75, col: 64, offset: 2588},
							name: "Quote",
						},
					},
				},
			},
		},
		{
			name: "PackageQuery",
			pos:  position{line: 79, col: 1, offset: 2683},
			expr: &actionExpr{
				pos: position{line: 79, col: 16, offset: 2698},
				run: (*parser).callonPackageQuery1,
				expr: &seqExpr{
					pos: position{line: 79, col: 17, offset: 2699},
					exprs: []interface{}{
						&labeledExpr{
							pos:   position{line: 79, col: 17, offset: 2699},
							label: "name",
							expr: &ruleRefExpr{
								pos:  position{line: 79, col: 22, offset: 2704},
								name: "PackageName",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 79, col: 34, offset: 2716},
							name: "Arobase",
						},
						&ruleRefExpr{
							pos:  position{line: 79, col: 42, offset: 2724},
							name: "VersionQuery",
						},
					},
				},
			},
		},
		{
			name: "PackageNameExpression",
			pos:  position{line: 84, col: 1, offset: 2821},
			expr: &choiceExpr{
				pos: position{line: 84, col: 26, offset: 2846},
				alternatives: []interface{}{
					&seqExpr{
						pos: position{line: 84, col: 26, offset: 2846},
						exprs: []interface{}{
							&ruleRefExpr{
								pos:  position{line: 84, col: 26, offset: 2846},
								name: "Quote",
							},
							&ruleRefExpr{
								pos:  position{line: 84, col: 32, offset: 2852},
								name: "PackageName",
							},
							&ruleRefExpr{
								pos:  position{line: 84, col: 44, offset: 2864},
								name: "Quote",
							},
						},
					},
					&ruleRefExpr{
						pos:  position{line: 84, col: 52, offset: 2872},
						name: "PackageName",
					},
				},
			},
		},
		{
			name: "PackageName",
			pos:  position{line: 85, col: 1, offset: 2885},
			expr: &choiceExpr{
				pos: position{line: 85, col: 15, offset: 2899},
				alternatives: []interface{}{
					&actionExpr{
						pos: position{line: 85, col: 15, offset: 2899},
						run: (*parser).callonPackageName2,
						expr: &seqExpr{
							pos: position{line: 85, col: 16, offset: 2900},
							exprs: []interface{}{
								&ruleRefExpr{
									pos:  position{line: 85, col: 16, offset: 2900},
									name: "Scope",
								},
								&ruleRefExpr{
									pos:  position{line: 85, col: 22, offset: 2906},
									name: "Slash",
								},
								&ruleRefExpr{
									pos:  position{line: 85, col: 28, offset: 2912},
									name: "PackageChars",
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 88, col: 7, offset: 3024},
						run: (*parser).callonPackageName7,
						expr: &ruleRefExpr{
							pos:  position{line: 88, col: 7, offset: 3024},
							name: "PackageChars",
						},
					},
				},
			},
		},
		{
			name: "VersionQueryExpression",
			pos:  position{line: 94, col: 1, offset: 3124},
			expr: &choiceExpr{
				pos: position{line: 94, col: 27, offset: 3150},
				alternatives: []interface{}{
					&seqExpr{
						pos: position{line: 94, col: 28, offset: 3151},
						exprs: []interface{}{
							&ruleRefExpr{
								pos:  position{line: 94, col: 28, offset: 3151},
								name: "Quote",
							},
							&oneOrMoreExpr{
								pos: position{line: 94, col: 34, offset: 3157},
								expr: &ruleRefExpr{
									pos:  position{line: 94, col: 34, offset: 3157},
									name: "NotQuote",
								},
							},
							&ruleRefExpr{
								pos:  position{line: 94, col: 44, offset: 3167},
								name: "Quote",
							},
						},
					},
					&oneOrMoreExpr{
						pos: position{line: 94, col: 53, offset: 3176},
						expr: &ruleRefExpr{
							pos:  position{line: 94, col: 54, offset: 3177},
							name: "NotColonCommentOrEOL",
						},
					},
				},
			},
		},
		{
			name:        "VersionExpression",
			displayName: "\"a quoted version number\"",
			pos:         position{line: 95, col: 1, offset: 3200},
			expr: &actionExpr{
				pos: position{line: 95, col: 47, offset: 3246},
				run: (*parser).callonVersionExpression1,
				expr: &seqExpr{
					pos: position{line: 95, col: 48, offset: 3247},
					exprs: []interface{}{
						&ruleRefExpr{
							pos:  position{line: 95, col: 48, offset: 3247},
							name: "Quote",
						},
						&labeledExpr{
							pos:   position{line: 95, col: 54, offset: 3253},
							label: "version",
							expr: &ruleRefExpr{
								pos:  position{line: 95, col: 62, offset: 3261},
								name: "Version",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 95, col: 70, offset: 3269},
							name: "Quote",
						},
					},
				},
			},
		},
		{
			name:        "Scope",
			displayName: "\"a scope\"",
			pos:         position{line: 99, col: 1, offset: 3369},
			expr: &seqExpr{
				pos: position{line: 99, col: 19, offset: 3387},
				exprs: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 99, col: 19, offset: 3387},
						name: "Arobase",
					},
					&ruleRefExpr{
						pos:  position{line: 99, col: 27, offset: 3395},
						name: "ScopeChars",
					},
				},
			},
		},
		{
			name:        "LCNM",
			displayName: "\"an empty or commented line\"",
			pos:         position{line: 101, col: 1, offset: 3407},
			expr: &choiceExpr{
				pos: position{line: 101, col: 37, offset: 3443},
				alternatives: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 101, col: 37, offset: 3443},
						name: "NewLine",
					},
					&ruleRefExpr{
						pos:  position{line: 101, col: 45, offset: 3451},
						name: "CommentLine",
					},
					&seqExpr{
						pos: position{line: 101, col: 58, offset: 3464},
						exprs: []interface{}{
							&oneOrMoreExpr{
								pos: position{line: 101, col: 58, offset: 3464},
								expr: &ruleRefExpr{
									pos:  position{line: 101, col: 58, offset: 3464},
									name: "_",
								},
							},
							&ruleRefExpr{
								pos:  position{line: 101, col: 61, offset: 3467},
								name: "NewLine",
							},
						},
					},
				},
			},
		},
		{
			name: "ROL",
			pos:  position{line: 103, col: 1, offset: 3477},
			expr: &choiceExpr{
				pos: position{line: 103, col: 7, offset: 3483},
				alternatives: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 103, col: 7, offset: 3483},
						name: "CommentLine",
					},
					&ruleRefExpr{
						pos:  position{line: 103, col: 21, offset: 3497},
						name: "EmptyRestOfLine",
					},
				},
			},
		},
		{
			name: "CommentLine",
			pos:  position{line: 104, col: 1, offset: 3513},
			expr: &seqExpr{
				pos: position{line: 104, col: 15, offset: 3527},
				exprs: []interface{}{
					&zeroOrMoreExpr{
						pos: position{line: 104, col: 15, offset: 3527},
						expr: &ruleRefExpr{
							pos:  position{line: 104, col: 15, offset: 3527},
							name: "_",
						},
					},
					&ruleRefExpr{
						pos:  position{line: 104, col: 18, offset: 3530},
						name: "Comment",
					},
					&ruleRefExpr{
						pos:  position{line: 104, col: 26, offset: 3538},
						name: "EOL",
					},
				},
			},
		},
		{
			name: "IgnoredRestOfLine",
			pos:  position{line: 105, col: 1, offset: 3542},
			expr: &seqExpr{
				pos: position{line: 105, col: 21, offset: 3562},
				exprs: []interface{}{
					&zeroOrOneExpr{
						pos: position{line: 105, col: 21, offset: 3562},
						expr: &ruleRefExpr{
							pos:  position{line: 105, col: 21, offset: 3562},
							name: "NotEOL",
						},
					},
					&ruleRefExpr{
						pos:  position{line: 105, col: 29, offset: 3570},
						name: "EOL",
					},
				},
			},
		},
		{
			name: "EmptyRestOfLine",
			pos:  position{line: 106, col: 1, offset: 3574},
			expr: &seqExpr{
				pos: position{line: 106, col: 19, offset: 3592},
				exprs: []interface{}{
					&zeroOrMoreExpr{
						pos: position{line: 106, col: 19, offset: 3592},
						expr: &ruleRefExpr{
							pos:  position{line: 106, col: 19, offset: 3592},
							name: "_",
						},
					},
					&ruleRefExpr{
						pos:  position{line: 106, col: 22, offset: 3595},
						name: "EOL",
					},
				},
			},
		},
		{
			name: "YarnLockfileVersionLine",
			pos:  position{line: 108, col: 1, offset: 3600},
			expr: &seqExpr{
				pos: position{line: 108, col: 27, offset: 3626},
				exprs: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 108, col: 27, offset: 3626},
						name: "Hash",
					},
					&ruleRefExpr{
						pos:  position{line: 108, col: 32, offset: 3631},
						name: "_",
					},
					&litMatcher{
						pos:        position{line: 108, col: 34, offset: 3633},
						val:        "yarn lockfile v1",
						ignoreCase: false,
					},
					&ruleRefExpr{
						pos:  position{line: 108, col: 53, offset: 3652},
						name: "EOL",
					},
				},
			},
		},
		{
			name: "Comment",
			pos:  position{line: 109, col: 1, offset: 3656},
			expr: &seqExpr{
				pos: position{line: 109, col: 11, offset: 3666},
				exprs: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 109, col: 11, offset: 3666},
						name: "Hash",
					},
					&ruleRefExpr{
						pos:  position{line: 109, col: 16, offset: 3671},
						name: "NotEOL",
					},
				},
			},
		},
		{
			name: "PackageChars",
			pos:  position{line: 111, col: 1, offset: 3679},
			expr: &seqExpr{
				pos: position{line: 111, col: 16, offset: 3694},
				exprs: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 111, col: 16, offset: 3694},
						name: "UrlSafeCharNoDotNoUnderscore",
					},
					&zeroOrMoreExpr{
						pos: position{line: 111, col: 45, offset: 3723},
						expr: &ruleRefExpr{
							pos:  position{line: 111, col: 45, offset: 3723},
							name: "UrlSafeChar",
						},
					},
				},
			},
		},
		{
			name: "ScopeChars",
			pos:  position{line: 112, col: 1, offset: 3736},
			expr: &seqExpr{
				pos: position{line: 112, col: 14, offset: 3749},
				exprs: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 112, col: 14, offset: 3749},
						name: "UrlSafeCharNoDotNoUnderscore",
					},
					&zeroOrMoreExpr{
						pos: position{line: 112, col: 43, offset: 3778},
						expr: &ruleRefExpr{
							pos:  position{line: 112, col: 43, offset: 3778},
							name: "UrlSafeChar",
						},
					},
				},
			},
		},
		{
			name: "VersionQuery",
			pos:  position{line: 114, col: 1, offset: 3792},
			expr: &choiceExpr{
				pos: position{line: 114, col: 17, offset: 3808},
				alternatives: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 114, col: 17, offset: 3808},
						name: "PathVersionQuery",
					},
					&ruleRefExpr{
						pos:  position{line: 114, col: 36, offset: 3827},
						name: "SemverVersionQuery",
					},
				},
			},
		},
		{
			name: "UrlVersionQuery",
			pos:  position{line: 116, col: 1, offset: 3847},
			expr: &oneOrMoreExpr{
				pos: position{line: 116, col: 19, offset: 3865},
				expr: &ruleRefExpr{
					pos:  position{line: 116, col: 19, offset: 3865},
					name: "ExtendedUrlSafeChar",
				},
			},
		},
		{
			name: "PathVersionQuery",
			pos:  position{line: 117, col: 1, offset: 3886},
			expr: &choiceExpr{
				pos: position{line: 117, col: 20, offset: 3905},
				alternatives: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 117, col: 20, offset: 3905},
						name: "PathOperator",
					},
					&oneOrMoreExpr{
						pos: position{line: 117, col: 35, offset: 3920},
						expr: &ruleRefExpr{
							pos:  position{line: 117, col: 35, offset: 3920},
							name: "PathSafeChar",
						},
					},
				},
			},
		},
		{
			name: "SemverVersionQuery",
			pos:  position{line: 118, col: 1, offset: 3934},
			expr: &oneOrMoreExpr{
				pos: position{line: 118, col: 22, offset: 3955},
				expr: &choiceExpr{
					pos: position{line: 118, col: 23, offset: 3956},
					alternatives: []interface{}{
						&ruleRefExpr{
							pos:  position{line: 118, col: 23, offset: 3956},
							name: "Digit",
						},
						&ruleRefExpr{
							pos:  position{line: 118, col: 31, offset: 3964},
							name: "Alpha",
						},
						&ruleRefExpr{
							pos:  position{line: 118, col: 39, offset: 3972},
							name: "VersionQueryWildcard",
						},
						&ruleRefExpr{
							pos:  position{line: 118, col: 62, offset: 3995},
							name: "VersionPunctuation",
						},
						&ruleRefExpr{
							pos:  position{line: 118, col: 83, offset: 4016},
							name: "VersionQueryOperator",
						},
						&ruleRefExpr{
							pos:  position{line: 118, col: 106, offset: 4039},
							name: "VersionQuerySeparator",
						},
					},
				},
			},
		},
		{
			name: "NotQuote",
			pos:  position{line: 120, col: 1, offset: 4065},
			expr: &charClassMatcher{
				pos:        position{line: 120, col: 12, offset: 4076},
				val:        "[^\"]",
				chars:      []rune{'"'},
				ignoreCase: false,
				inverted:   true,
			},
		},
		{
			name: "NotCommentOrEOL",
			pos:  position{line: 121, col: 1, offset: 4081},
			expr: &charClassMatcher{
				pos:        position{line: 121, col: 19, offset: 4099},
				val:        "[^:#\\r\\n]",
				chars:      []rune{':', '#', '\r', '\n'},
				ignoreCase: false,
				inverted:   true,
			},
		},
		{
			name: "NotColonCommentOrEOL",
			pos:  position{line: 122, col: 1, offset: 4109},
			expr: &charClassMatcher{
				pos:        position{line: 122, col: 24, offset: 4132},
				val:        "[^:#\\r\\n]",
				chars:      []rune{':', '#', '\r', '\n'},
				ignoreCase: false,
				inverted:   true,
			},
		},
		{
			name: "PathOperator",
			pos:  position{line: 123, col: 1, offset: 4142},
			expr: &litMatcher{
				pos:        position{line: 123, col: 16, offset: 4157},
				val:        "/",
				ignoreCase: false,
			},
		},
		{
			name: "VersionQueryOperator",
			pos:  position{line: 124, col: 1, offset: 4161},
			expr: &choiceExpr{
				pos: position{line: 124, col: 24, offset: 4184},
				alternatives: []interface{}{
					&litMatcher{
						pos:        position{line: 124, col: 24, offset: 4184},
						val:        "^",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 124, col: 30, offset: 4190},
						val:        "~",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 124, col: 36, offset: 4196},
						val:        "<",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 124, col: 42, offset: 4202},
						val:        ">",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 124, col: 48, offset: 4208},
						val:        "=",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 124, col: 54, offset: 4214},
						val:        "!",
						ignoreCase: false,
					},
				},
			},
		},
		{
			name: "VersionQuerySeparator",
			pos:  position{line: 125, col: 1, offset: 4218},
			expr: &choiceExpr{
				pos: position{line: 125, col: 25, offset: 4242},
				alternatives: []interface{}{
					&litMatcher{
						pos:        position{line: 125, col: 25, offset: 4242},
						val:        "|",
						ignoreCase: false,
					},
					&ruleRefExpr{
						pos:  position{line: 125, col: 31, offset: 4248},
						name: "_",
					},
				},
			},
		},
		{
			name: "VersionQueryWildcard",
			pos:  position{line: 126, col: 1, offset: 4250},
			expr: &choiceExpr{
				pos: position{line: 126, col: 24, offset: 4273},
				alternatives: []interface{}{
					&litMatcher{
						pos:        position{line: 126, col: 24, offset: 4273},
						val:        "x",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 126, col: 30, offset: 4279},
						val:        "X",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 126, col: 36, offset: 4285},
						val:        "*",
						ignoreCase: false,
					},
				},
			},
		},
		{
			name:        "Version",
			displayName: "\"a version number\"",
			pos:         position{line: 128, col: 1, offset: 4290},
			expr: &actionExpr{
				pos: position{line: 128, col: 30, offset: 4319},
				run: (*parser).callonVersion1,
				expr: &oneOrMoreExpr{
					pos: position{line: 128, col: 30, offset: 4319},
					expr: &choiceExpr{
						pos: position{line: 128, col: 31, offset: 4320},
						alternatives: []interface{}{
							&ruleRefExpr{
								pos:  position{line: 128, col: 31, offset: 4320},
								name: "Digit",
							},
							&ruleRefExpr{
								pos:  position{line: 128, col: 39, offset: 4328},
								name: "Alpha",
							},
							&ruleRefExpr{
								pos:  position{line: 128, col: 47, offset: 4336},
								name: "VersionPunctuation",
							},
						},
					},
				},
			},
		},
		{
			name: "VersionPunctuation",
			pos:  position{line: 133, col: 1, offset: 4437},
			expr: &choiceExpr{
				pos: position{line: 133, col: 22, offset: 4458},
				alternatives: []interface{}{
					&litMatcher{
						pos:        position{line: 133, col: 22, offset: 4458},
						val:        ".",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 133, col: 28, offset: 4464},
						val:        "-",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 133, col: 34, offset: 4470},
						val:        "+",
						ignoreCase: false,
					},
				},
			},
		},
		{
			name: "Alpha",
			pos:  position{line: 135, col: 1, offset: 4475},
			expr: &charClassMatcher{
				pos:        position{line: 135, col: 9, offset: 4483},
				val:        "[a-zA-Z]",
				ranges:     []rune{'a', 'z', 'A', 'Z'},
				ignoreCase: false,
				inverted:   false,
			},
		},
		{
			name: "Digit",
			pos:  position{line: 136, col: 1, offset: 4492},
			expr: &charClassMatcher{
				pos:        position{line: 136, col: 9, offset: 4500},
				val:        "[0-9]",
				ranges:     []rune{'0', '9'},
				ignoreCase: false,
				inverted:   false,
			},
		},
		{
			name: "ExtendedUrlSafeChar",
			pos:  position{line: 138, col: 1, offset: 4507},
			expr: &choiceExpr{
				pos: position{line: 138, col: 23, offset: 4529},
				alternatives: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 138, col: 23, offset: 4529},
						name: "PathSafeChar",
					},
					&litMatcher{
						pos:        position{line: 138, col: 38, offset: 4544},
						val:        ":",
						ignoreCase: false,
					},
				},
			},
		},
		{
			name: "PathSafeCharNoArobase",
			pos:  position{line: 139, col: 1, offset: 4548},
			expr: &choiceExpr{
				pos: position{line: 139, col: 25, offset: 4572},
				alternatives: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 139, col: 25, offset: 4572},
						name: "UrlSafeChar",
					},
					&litMatcher{
						pos:        position{line: 139, col: 39, offset: 4586},
						val:        "+",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 139, col: 45, offset: 4592},
						val:        "/",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 139, col: 51, offset: 4598},
						val:        "%",
						ignoreCase: false,
					},
				},
			},
		},
		{
			name: "PathSafeChar",
			pos:  position{line: 140, col: 1, offset: 4602},
			expr: &choiceExpr{
				pos: position{line: 140, col: 16, offset: 4617},
				alternatives: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 140, col: 16, offset: 4617},
						name: "UrlSafeChar",
					},
					&litMatcher{
						pos:        position{line: 140, col: 30, offset: 4631},
						val:        "+",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 140, col: 36, offset: 4637},
						val:        "@",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 140, col: 42, offset: 4643},
						val:        "/",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 140, col: 48, offset: 4649},
						val:        "%",
						ignoreCase: false,
					},
				},
			},
		},
		{
			name: "UrlSafeCharNoDotNoUnderscore",
			pos:  position{line: 141, col: 1, offset: 4653},
			expr: &choiceExpr{
				pos: position{line: 141, col: 32, offset: 4684},
				alternatives: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 141, col: 32, offset: 4684},
						name: "Alpha",
					},
					&ruleRefExpr{
						pos:  position{line: 141, col: 40, offset: 4692},
						name: "Digit",
					},
					&litMatcher{
						pos:        position{line: 141, col: 48, offset: 4700},
						val:        "-",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 141, col: 54, offset: 4706},
						val:        "~",
						ignoreCase: false,
					},
				},
			},
		},
		{
			name: "UrlSafeChar",
			pos:  position{line: 142, col: 1, offset: 4710},
			expr: &choiceExpr{
				pos: position{line: 142, col: 15, offset: 4724},
				alternatives: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 142, col: 15, offset: 4724},
						name: "Alpha",
					},
					&ruleRefExpr{
						pos:  position{line: 142, col: 23, offset: 4732},
						name: "Digit",
					},
					&litMatcher{
						pos:        position{line: 142, col: 31, offset: 4740},
						val:        "-",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 142, col: 37, offset: 4746},
						val:        ".",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 142, col: 43, offset: 4752},
						val:        "_",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 142, col: 49, offset: 4758},
						val:        "~",
						ignoreCase: false,
					},
				},
			},
		},
		{
			name:        "Hash",
			displayName: "\"a hash\"",
			pos:         position{line: 144, col: 1, offset: 4763},
			expr: &litMatcher{
				pos:        position{line: 144, col: 17, offset: 4779},
				val:        "#",
				ignoreCase: false,
			},
		},
		{
			name:        "Quote",
			displayName: "\"a double quote\"",
			pos:         position{line: 145, col: 1, offset: 4783},
			expr: &litMatcher{
				pos:        position{line: 145, col: 25, offset: 4807},
				val:        "\"",
				ignoreCase: false,
			},
		},
		{
			name:        "Comma",
			displayName: "\"a comma\"",
			pos:         position{line: 146, col: 1, offset: 4812},
			expr: &litMatcher{
				pos:        position{line: 146, col: 19, offset: 4830},
				val:        ",",
				ignoreCase: false,
			},
		},
		{
			name:        "Colon",
			displayName: "\"a colon\"",
			pos:         position{line: 147, col: 1, offset: 4834},
			expr: &litMatcher{
				pos:        position{line: 147, col: 19, offset: 4852},
				val:        ":",
				ignoreCase: false,
			},
		},
		{
			name:        "Arobase",
			displayName: "\"an arobase\"",
			pos:         position{line: 148, col: 1, offset: 4856},
			expr: &litMatcher{
				pos:        position{line: 148, col: 24, offset: 4879},
				val:        "@",
				ignoreCase: false,
			},
		},
		{
			name:        "Slash",
			displayName: "\"a slash\"",
			pos:         position{line: 149, col: 1, offset: 4883},
			expr: &litMatcher{
				pos:        position{line: 149, col: 19, offset: 4901},
				val:        "/",
				ignoreCase: false,
			},
		},
		{
			name:        "NotEOL",
			displayName: "\"any character but EOL/EOF\"",
			pos:         position{line: 151, col: 1, offset: 4906},
			expr: &zeroOrMoreExpr{
				pos: position{line: 151, col: 38, offset: 4943},
				expr: &charClassMatcher{
					pos:        position{line: 151, col: 38, offset: 4943},
					val:        "[^\\r\\n]",
					chars:      []rune{'\r', '\n'},
					ignoreCase: false,
					inverted:   true,
				},
			},
		},
		{
			name:        "EOL",
			displayName: "\"End of Line (EOL) or End of File (EOF)\"",
			pos:         position{line: 152, col: 1, offset: 4952},
			expr: &choiceExpr{
				pos: position{line: 152, col: 48, offset: 4999},
				alternatives: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 152, col: 48, offset: 4999},
						name: "NewLine",
					},
					&ruleRefExpr{
						pos:  position{line: 152, col: 58, offset: 5009},
						name: "EOF",
					},
				},
			},
		},
		{
			name: "NewLine",
			pos:  position{line: 153, col: 1, offset: 5013},
			expr: &choiceExpr{
				pos: position{line: 153, col: 11, offset: 5023},
				alternatives: []interface{}{
					&litMatcher{
						pos:        position{line: 153, col: 11, offset: 5023},
						val:        "\r\n",
						ignoreCase: false,
					},
					&litMatcher{
						pos:        position{line: 153, col: 20, offset: 5032},
						val:        "\n",
						ignoreCase: false,
					},
				},
			},
		},
		{
			name:        "____",
			displayName: "\"double indent\"",
			pos:         position{line: 155, col: 1, offset: 5038},
			expr: &seqExpr{
				pos: position{line: 155, col: 24, offset: 5061},
				exprs: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 155, col: 24, offset: 5061},
						name: "__",
					},
					&ruleRefExpr{
						pos:  position{line: 155, col: 27, offset: 5064},
						name: "__",
					},
				},
			},
		},
		{
			name:        "__",
			displayName: "\"single indent\"",
			pos:         position{line: 156, col: 1, offset: 5067},
			expr: &seqExpr{
				pos: position{line: 156, col: 22, offset: 5088},
				exprs: []interface{}{
					&ruleRefExpr{
						pos:  position{line: 156, col: 22, offset: 5088},
						name: "indent",
					},
					&ruleRefExpr{
						pos:  position{line: 156, col: 29, offset: 5095},
						name: "indent",
					},
				},
			},
		},
		{
			name: "indent",
			pos:  position{line: 158, col: 1, offset: 5103},
			expr: &charClassMatcher{
				pos:        position{line: 158, col: 10, offset: 5112},
				val:        "[ \\t]",
				chars:      []rune{' ', '\t'},
				ignoreCase: false,
				inverted:   false,
			},
		},
		{
			name:        "_",
			displayName: "\"a whitespace\"",
			pos:         position{line: 160, col: 1, offset: 5119},
			expr: &charClassMatcher{
				pos:        position{line: 160, col: 20, offset: 5138},
				val:        "[ \\t]",
				chars:      []rune{' ', '\t'},
				ignoreCase: false,
				inverted:   false,
			},
		},
		{
			name: "EOF",
			pos:  position{line: 162, col: 1, offset: 5145},
			expr: &notExpr{
				pos: position{line: 162, col: 7, offset: 5151},
				expr: &anyMatcher{
					line: 162, col: 8, offset: 5152,
				},
			},
		},
	},
}

func (c *current) onInput1(deps interface{}) (interface{}, error) {
	return deps.([]nodepackage.NodePackage), nil
}

func (p *parser) callonInput1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInput1(stack["deps"])
}

func (c *current) onBody1(deps interface{}) (interface{}, error) {
	log.Debug("👽 Body", deps)

	depsSl := toIfaceSlice(deps)
	var castedDeps []nodepackage.NodePackage
	for _, dep := range depsSl {
		castedDeps = append(castedDeps, dep.(nodepackage.NodePackage))
	}
	return castedDeps, nil
}

func (p *parser) callonBody1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onBody1(stack["deps"])
}

func (c *current) onDependency1(name, version interface{}) (interface{}, error) {
	dep := nodepackage.NodePackage{Name: name.(string), Version: version.(string)}
	log.Debug("👽 Package of DependencyHeaderLine: ", dep)
	return dep, nil
}

func (p *parser) callonDependency1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onDependency1(stack["name"], stack["version"])
}

func (c *current) onDependencyHeaderLine1(name interface{}) (interface{}, error) {
	log.Debug("👽 Package of DependencyHeaderLine: ", name.(string))
	return name.(string), nil
}

func (p *parser) callonDependencyHeaderLine1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onDependencyHeaderLine1(stack["name"])
}

func (c *current) onDependencyVersionLine1(version interface{}) (interface{}, error) {
	log.Debug("👽 Package of DependencyVersionLine: ", version.(string))
	return version.(string), nil
}

func (p *parser) callonDependencyVersionLine1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onDependencyVersionLine1(stack["version"])
}

func (c *current) onListOfPackageQueryExpression1(name interface{}) (interface{}, error) {
	log.Debug("👽 Package of ListOfPackageQueryExpression: ", name.(string))
	return name.(string), nil
}

func (p *parser) callonListOfPackageQueryExpression1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onListOfPackageQueryExpression1(stack["name"])
}

func (c *current) onPackageQueryExpression1(name interface{}) (interface{}, error) {
	log.Debug("👽 PackageQueryExpression: ", name.(string))
	return name.(string), nil
}

func (p *parser) callonPackageQueryExpression1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onPackageQueryExpression1(stack["name"])
}

func (c *current) onQuotedPackageQuery1(name interface{}) (interface{}, error) {
	log.Debug("👽 QuotedPackageQuery: ", name.(string))
	return name.(string), nil
}

func (p *parser) callonQuotedPackageQuery1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onQuotedPackageQuery1(stack["name"])
}

func (c *current) onPackageQuery1(name interface{}) (interface{}, error) {
	log.Debug("👽 PackageQuery: ", name.(string))
	return name.(string), nil
}

func (p *parser) callonPackageQuery1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onPackageQuery1(stack["name"])
}

func (c *current) onPackageName2() (interface{}, error) {
	log.Debug("👽 Package with Scope: ", string(c.text))
	return string(c.text), nil

}

func (p *parser) callonPackageName2() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onPackageName2()
}

func (c *current) onPackageName7() (interface{}, error) {
	log.Debug("👽 Package: ", string(c.text))
	return string(c.text), nil

}

func (p *parser) callonPackageName7() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onPackageName7()
}

func (c *current) onVersionExpression1(version interface{}) (interface{}, error) {
	log.Debug("👽 VersionExpression: ", version.(string))
	return version.(string), nil
}

func (p *parser) callonVersionExpression1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onVersionExpression1(stack["version"])
}

func (c *current) onVersion1() (interface{}, error) {
	log.Debug("👽 Version: ", string(c.text))
	return string(c.text), nil
}

func (p *parser) callonVersion1() (interface{}, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onVersion1()
}

var (
	// errNoRule is returned when the grammar to parse has no rule.
	errNoRule = errors.New("grammar has no rule")

	// errInvalidEntrypoint is returned when the specified entrypoint rule
	// does not exit.
	errInvalidEntrypoint = errors.New("invalid entrypoint")

	// errInvalidEncoding is returned when the source is not properly
	// utf8-encoded.
	errInvalidEncoding = errors.New("invalid encoding")

	// errMaxExprCnt is used to signal that the maximum number of
	// expressions have been parsed.
	errMaxExprCnt = errors.New("max number of expresssions parsed")
)

// Option is a function that can set an option on the parser. It returns
// the previous setting as an Option.
type Option func(*parser) Option

// MaxExpressions creates an Option to stop parsing after the provided
// number of expressions have been parsed, if the value is 0 then the parser will
// parse for as many steps as needed (possibly an infinite number).
//
// The default for maxExprCnt is 0.
func MaxExpressions(maxExprCnt uint64) Option {
	return func(p *parser) Option {
		oldMaxExprCnt := p.maxExprCnt
		p.maxExprCnt = maxExprCnt
		return MaxExpressions(oldMaxExprCnt)
	}
}

// Entrypoint creates an Option to set the rule name to use as entrypoint.
// The rule name must have been specified in the -alternate-entrypoints
// if generating the parser with the -optimize-grammar flag, otherwise
// it may have been optimized out. Passing an empty string sets the
// entrypoint to the first rule in the grammar.
//
// The default is to start parsing at the first rule in the grammar.
func Entrypoint(ruleName string) Option {
	return func(p *parser) Option {
		oldEntrypoint := p.entrypoint
		p.entrypoint = ruleName
		if ruleName == "" {
			p.entrypoint = g.rules[0].name
		}
		return Entrypoint(oldEntrypoint)
	}
}

// Statistics adds a user provided Stats struct to the parser to allow
// the user to process the results after the parsing has finished.
// Also the key for the "no match" counter is set.
//
// Example usage:
//
//     input := "input"
//     stats := Stats{}
//     _, err := Parse("input-file", []byte(input), Statistics(&stats, "no match"))
//     if err != nil {
//         log.Panicln(err)
//     }
//     b, err := json.MarshalIndent(stats.ChoiceAltCnt, "", "  ")
//     if err != nil {
//         log.Panicln(err)
//     }
//     fmt.Println(string(b))
//
func Statistics(stats *Stats, choiceNoMatch string) Option {
	return func(p *parser) Option {
		oldStats := p.Stats
		p.Stats = stats
		oldChoiceNoMatch := p.choiceNoMatch
		p.choiceNoMatch = choiceNoMatch
		if p.Stats.ChoiceAltCnt == nil {
			p.Stats.ChoiceAltCnt = make(map[string]map[string]int)
		}
		return Statistics(oldStats, oldChoiceNoMatch)
	}
}

// Debug creates an Option to set the debug flag to b. When set to true,
// debugging information is printed to stdout while parsing.
//
// The default is false.
func Debug(b bool) Option {
	return func(p *parser) Option {
		old := p.debug
		p.debug = b
		return Debug(old)
	}
}

// Memoize creates an Option to set the memoize flag to b. When set to true,
// the parser will cache all results so each expression is evaluated only
// once. This guarantees linear parsing time even for pathological cases,
// at the expense of more memory and slower times for typical cases.
//
// The default is false.
func Memoize(b bool) Option {
	return func(p *parser) Option {
		old := p.memoize
		p.memoize = b
		return Memoize(old)
	}
}

// AllowInvalidUTF8 creates an Option to allow invalid UTF-8 bytes.
// Every invalid UTF-8 byte is treated as a utf8.RuneError (U+FFFD)
// by character class matchers and is matched by the any matcher.
// The returned matched value, c.text and c.offset are NOT affected.
//
// The default is false.
func AllowInvalidUTF8(b bool) Option {
	return func(p *parser) Option {
		old := p.allowInvalidUTF8
		p.allowInvalidUTF8 = b
		return AllowInvalidUTF8(old)
	}
}

// Recover creates an Option to set the recover flag to b. When set to
// true, this causes the parser to recover from panics and convert it
// to an error. Setting it to false can be useful while debugging to
// access the full stack trace.
//
// The default is true.
func Recover(b bool) Option {
	return func(p *parser) Option {
		old := p.recover
		p.recover = b
		return Recover(old)
	}
}

// GlobalStore creates an Option to set a key to a certain value in
// the globalStore.
func GlobalStore(key string, value interface{}) Option {
	return func(p *parser) Option {
		old := p.cur.globalStore[key]
		p.cur.globalStore[key] = value
		return GlobalStore(key, old)
	}
}

// InitState creates an Option to set a key to a certain value in
// the global "state" store.
func InitState(key string, value interface{}) Option {
	return func(p *parser) Option {
		old := p.cur.state[key]
		p.cur.state[key] = value
		return InitState(key, old)
	}
}

// ParseFile parses the file identified by filename.
func ParseFile(filename string, opts ...Option) (i interface{}, err error) {
	f, err := os.Open(filename)
	if err != nil {
		return nil, err
	}
	defer func() {
		if closeErr := f.Close(); closeErr != nil {
			err = closeErr
		}
	}()
	return ParseReader(filename, f, opts...)
}

// ParseReader parses the data from r using filename as information in the
// error messages.
func ParseReader(filename string, r io.Reader, opts ...Option) (interface{}, error) {
	b, err := ioutil.ReadAll(r)
	if err != nil {
		return nil, err
	}

	return Parse(filename, b, opts...)
}

// Parse parses the data from b using filename as information in the
// error messages.
func Parse(filename string, b []byte, opts ...Option) (interface{}, error) {
	return newParser(filename, b, opts...).parse(g)
}

// position records a position in the text.
type position struct {
	line, col, offset int
}

func (p position) String() string {
	return fmt.Sprintf("%d:%d [%d]", p.line, p.col, p.offset)
}

// savepoint stores all state required to go back to this point in the
// parser.
type savepoint struct {
	position
	rn rune
	w  int
}

type current struct {
	pos  position // start position of the match
	text []byte   // raw text of the match

	// state is a store for arbitrary key,value pairs that the user wants to be
	// tied to the backtracking of the parser.
	// This is always rolled back if a parsing rule fails.
	state storeDict

	// globalStore is a general store for the user to store arbitrary key-value
	// pairs that they need to manage and that they do not want tied to the
	// backtracking of the parser. This is only modified by the user and never
	// rolled back by the parser. It is always up to the user to keep this in a
	// consistent state.
	globalStore storeDict
}

type storeDict map[string]interface{}

// the AST types...

type grammar struct {
	pos   position
	rules []*rule
}

type rule struct {
	pos         position
	name        string
	displayName string
	expr        interface{}
}

type choiceExpr struct {
	pos          position
	alternatives []interface{}
}

type actionExpr struct {
	pos  position
	expr interface{}
	run  func(*parser) (interface{}, error)
}

type recoveryExpr struct {
	pos          position
	expr         interface{}
	recoverExpr  interface{}
	failureLabel []string
}

type seqExpr struct {
	pos   position
	exprs []interface{}
}

type throwExpr struct {
	pos   position
	label string
}

type labeledExpr struct {
	pos   position
	label string
	expr  interface{}
}

type expr struct {
	pos  position
	expr interface{}
}

type andExpr expr
type notExpr expr
type zeroOrOneExpr expr
type zeroOrMoreExpr expr
type oneOrMoreExpr expr

type ruleRefExpr struct {
	pos  position
	name string
}

type stateCodeExpr struct {
	pos position
	run func(*parser) error
}

type andCodeExpr struct {
	pos position
	run func(*parser) (bool, error)
}

type notCodeExpr struct {
	pos position
	run func(*parser) (bool, error)
}

type litMatcher struct {
	pos        position
	val        string
	ignoreCase bool
}

type charClassMatcher struct {
	pos             position
	val             string
	basicLatinChars [128]bool
	chars           []rune
	ranges          []rune
	classes         []*unicode.RangeTable
	ignoreCase      bool
	inverted        bool
}

type anyMatcher position

// errList cumulates the errors found by the parser.
type errList []error

func (e *errList) add(err error) {
	*e = append(*e, err)
}

func (e errList) err() error {
	if len(e) == 0 {
		return nil
	}
	e.dedupe()
	return e
}

func (e *errList) dedupe() {
	var cleaned []error
	set := make(map[string]bool)
	for _, err := range *e {
		if msg := err.Error(); !set[msg] {
			set[msg] = true
			cleaned = append(cleaned, err)
		}
	}
	*e = cleaned
}

func (e errList) Error() string {
	switch len(e) {
	case 0:
		return ""
	case 1:
		return e[0].Error()
	default:
		var buf bytes.Buffer

		for i, err := range e {
			if i > 0 {
				buf.WriteRune('\n')
			}
			buf.WriteString(err.Error())
		}
		return buf.String()
	}
}

// parserError wraps an error with a prefix indicating the rule in which
// the error occurred. The original error is stored in the Inner field.
type parserError struct {
	Inner    error
	pos      position
	prefix   string
	expected []string
}

// Error returns the error message.
func (p *parserError) Error() string {
	return p.prefix + ": " + p.Inner.Error()
}

// newParser creates a parser with the specified input source and options.
func newParser(filename string, b []byte, opts ...Option) *parser {
	stats := Stats{
		ChoiceAltCnt: make(map[string]map[string]int),
	}

	p := &parser{
		filename: filename,
		errs:     new(errList),
		data:     b,
		pt:       savepoint{position: position{line: 1}},
		recover:  true,
		cur: current{
			state:       make(storeDict),
			globalStore: make(storeDict),
		},
		maxFailPos:      position{col: 1, line: 1},
		maxFailExpected: make([]string, 0, 20),
		Stats:           &stats,
		// start rule is rule [0] unless an alternate entrypoint is specified
		entrypoint: g.rules[0].name,
		emptyState: make(storeDict),
	}
	p.setOptions(opts)

	if p.maxExprCnt == 0 {
		p.maxExprCnt = math.MaxUint64
	}

	return p
}

// setOptions applies the options to the parser.
func (p *parser) setOptions(opts []Option) {
	for _, opt := range opts {
		opt(p)
	}
}

type resultTuple struct {
	v   interface{}
	b   bool
	end savepoint
}

const choiceNoMatch = -1

// Stats stores some statistics, gathered during parsing
type Stats struct {
	// ExprCnt counts the number of expressions processed during parsing
	// This value is compared to the maximum number of expressions allowed
	// (set by the MaxExpressions option).
	ExprCnt uint64

	// ChoiceAltCnt is used to count for each ordered choice expression,
	// which alternative is used how may times.
	// These numbers allow to optimize the order of the ordered choice expression
	// to increase the performance of the parser
	//
	// The outer key of ChoiceAltCnt is composed of the name of the rule as well
	// as the line and the column of the ordered choice.
	// The inner key of ChoiceAltCnt is the number (one-based) of the matching alternative.
	// For each alternative the number of matches are counted. If an ordered choice does not
	// match, a special counter is incremented. The name of this counter is set with
	// the parser option Statistics.
	// For an alternative to be included in ChoiceAltCnt, it has to match at least once.
	ChoiceAltCnt map[string]map[string]int
}

type parser struct {
	filename string
	pt       savepoint
	cur      current

	data []byte
	errs *errList

	depth   int
	recover bool
	debug   bool

	memoize bool
	// memoization table for the packrat algorithm:
	// map[offset in source] map[expression or rule] {value, match}
	memo map[int]map[interface{}]resultTuple

	// rules table, maps the rule identifier to the rule node
	rules map[string]*rule
	// variables stack, map of label to value
	vstack []map[string]interface{}
	// rule stack, allows identification of the current rule in errors
	rstack []*rule

	// parse fail
	maxFailPos            position
	maxFailExpected       []string
	maxFailInvertExpected bool

	// max number of expressions to be parsed
	maxExprCnt uint64
	// entrypoint for the parser
	entrypoint string

	allowInvalidUTF8 bool

	*Stats

	choiceNoMatch string
	// recovery expression stack, keeps track of the currently available recovery expression, these are traversed in reverse
	recoveryStack []map[string]interface{}

	// emptyState contains an empty storeDict, which is used to optimize cloneState if global "state" store is not used.
	emptyState storeDict
}

// push a variable set on the vstack.
func (p *parser) pushV() {
	if cap(p.vstack) == len(p.vstack) {
		// create new empty slot in the stack
		p.vstack = append(p.vstack, nil)
	} else {
		// slice to 1 more
		p.vstack = p.vstack[:len(p.vstack)+1]
	}

	// get the last args set
	m := p.vstack[len(p.vstack)-1]
	if m != nil && len(m) == 0 {
		// empty map, all good
		return
	}

	m = make(map[string]interface{})
	p.vstack[len(p.vstack)-1] = m
}

// pop a variable set from the vstack.
func (p *parser) popV() {
	// if the map is not empty, clear it
	m := p.vstack[len(p.vstack)-1]
	if len(m) > 0 {
		// GC that map
		p.vstack[len(p.vstack)-1] = nil
	}
	p.vstack = p.vstack[:len(p.vstack)-1]
}

// push a recovery expression with its labels to the recoveryStack
func (p *parser) pushRecovery(labels []string, expr interface{}) {
	if cap(p.recoveryStack) == len(p.recoveryStack) {
		// create new empty slot in the stack
		p.recoveryStack = append(p.recoveryStack, nil)
	} else {
		// slice to 1 more
		p.recoveryStack = p.recoveryStack[:len(p.recoveryStack)+1]
	}

	m := make(map[string]interface{}, len(labels))
	for _, fl := range labels {
		m[fl] = expr
	}
	p.recoveryStack[len(p.recoveryStack)-1] = m
}

// pop a recovery expression from the recoveryStack
func (p *parser) popRecovery() {
	// GC that map
	p.recoveryStack[len(p.recoveryStack)-1] = nil

	p.recoveryStack = p.recoveryStack[:len(p.recoveryStack)-1]
}

func (p *parser) print(prefix, s string) string {
	if !p.debug {
		return s
	}

	fmt.Printf("%s %d:%d:%d: %s [%#U]\n",
		prefix, p.pt.line, p.pt.col, p.pt.offset, s, p.pt.rn)
	return s
}

func (p *parser) in(s string) string {
	p.depth++
	return p.print(strings.Repeat(" ", p.depth)+">", s)
}

func (p *parser) out(s string) string {
	p.depth--
	return p.print(strings.Repeat(" ", p.depth)+"<", s)
}

func (p *parser) addErr(err error) {
	p.addErrAt(err, p.pt.position, []string{})
}

func (p *parser) addErrAt(err error, pos position, expected []string) {
	var buf bytes.Buffer
	if p.filename != "" {
		buf.WriteString(p.filename)
	}
	if buf.Len() > 0 {
		buf.WriteString(":")
	}
	buf.WriteString(fmt.Sprintf("%d:%d (%d)", pos.line, pos.col, pos.offset))
	if len(p.rstack) > 0 {
		if buf.Len() > 0 {
			buf.WriteString(": ")
		}
		rule := p.rstack[len(p.rstack)-1]
		if rule.displayName != "" {
			buf.WriteString("rule " + rule.displayName)
		} else {
			buf.WriteString("rule " + rule.name)
		}
	}
	pe := &parserError{Inner: err, pos: pos, prefix: buf.String(), expected: expected}
	p.errs.add(pe)
}

func (p *parser) failAt(fail bool, pos position, want string) {
	// process fail if parsing fails and not inverted or parsing succeeds and invert is set
	if fail == p.maxFailInvertExpected {
		if pos.offset < p.maxFailPos.offset {
			return
		}

		if pos.offset > p.maxFailPos.offset {
			p.maxFailPos = pos
			p.maxFailExpected = p.maxFailExpected[:0]
		}

		if p.maxFailInvertExpected {
			want = "!" + want
		}
		p.maxFailExpected = append(p.maxFailExpected, want)
	}
}

// read advances the parser to the next rune.
func (p *parser) read() {
	p.pt.offset += p.pt.w
	rn, n := utf8.DecodeRune(p.data[p.pt.offset:])
	p.pt.rn = rn
	p.pt.w = n
	p.pt.col++
	if rn == '\n' {
		p.pt.line++
		p.pt.col = 0
	}

	if rn == utf8.RuneError && n == 1 { // see utf8.DecodeRune
		if !p.allowInvalidUTF8 {
			p.addErr(errInvalidEncoding)
		}
	}
}

// restore parser position to the savepoint pt.
func (p *parser) restore(pt savepoint) {
	if p.debug {
		defer p.out(p.in("restore"))
	}
	if pt.offset == p.pt.offset {
		return
	}
	p.pt = pt
}

// Cloner is implemented by any value that has a Clone method, which returns a
// copy of the value. This is mainly used for types which are not passed by
// value (e.g map, slice, chan) or structs that contain such types.
//
// This is used in conjunction with the global state feature to create proper
// copies of the state to allow the parser to properly restore the state in
// the case of backtracking.
type Cloner interface {
	Clone() interface{}
}

// clone and return parser current state.
func (p *parser) cloneState() storeDict {
	if p.debug {
		defer p.out(p.in("cloneState"))
	}

	if len(p.cur.state) == 0 {
		if len(p.emptyState) > 0 {
			p.emptyState = make(storeDict)
		}
		return p.emptyState
	}

	state := make(storeDict, len(p.cur.state))
	for k, v := range p.cur.state {
		if c, ok := v.(Cloner); ok {
			state[k] = c.Clone()
		} else {
			state[k] = v
		}
	}
	return state
}

// restore parser current state to the state storeDict.
// every restoreState should applied only one time for every cloned state
func (p *parser) restoreState(state storeDict) {
	if p.debug {
		defer p.out(p.in("restoreState"))
	}
	p.cur.state = state
}

// get the slice of bytes from the savepoint start to the current position.
func (p *parser) sliceFrom(start savepoint) []byte {
	return p.data[start.position.offset:p.pt.position.offset]
}

func (p *parser) getMemoized(node interface{}) (resultTuple, bool) {
	if len(p.memo) == 0 {
		return resultTuple{}, false
	}
	m := p.memo[p.pt.offset]
	if len(m) == 0 {
		return resultTuple{}, false
	}
	res, ok := m[node]
	return res, ok
}

func (p *parser) setMemoized(pt savepoint, node interface{}, tuple resultTuple) {
	if p.memo == nil {
		p.memo = make(map[int]map[interface{}]resultTuple)
	}
	m := p.memo[pt.offset]
	if m == nil {
		m = make(map[interface{}]resultTuple)
		p.memo[pt.offset] = m
	}
	m[node] = tuple
}

func (p *parser) buildRulesTable(g *grammar) {
	p.rules = make(map[string]*rule, len(g.rules))
	for _, r := range g.rules {
		p.rules[r.name] = r
	}
}

func (p *parser) parse(g *grammar) (val interface{}, err error) {
	if len(g.rules) == 0 {
		p.addErr(errNoRule)
		return nil, p.errs.err()
	}

	// TODO : not super critical but this could be generated
	p.buildRulesTable(g)

	if p.recover {
		// panic can be used in action code to stop parsing immediately
		// and return the panic as an error.
		defer func() {
			if e := recover(); e != nil {
				if p.debug {
					defer p.out(p.in("panic handler"))
				}
				val = nil
				switch e := e.(type) {
				case error:
					p.addErr(e)
				default:
					p.addErr(fmt.Errorf("%v", e))
				}
				err = p.errs.err()
			}
		}()
	}

	startRule, ok := p.rules[p.entrypoint]
	if !ok {
		p.addErr(errInvalidEntrypoint)
		return nil, p.errs.err()
	}

	p.read() // advance to first rune
	val, ok = p.parseRule(startRule)
	if !ok {
		if len(*p.errs) == 0 {
			// If parsing fails, but no errors have been recorded, the expected values
			// for the farthest parser position are returned as error.
			maxFailExpectedMap := make(map[string]struct{}, len(p.maxFailExpected))
			for _, v := range p.maxFailExpected {
				maxFailExpectedMap[v] = struct{}{}
			}
			expected := make([]string, 0, len(maxFailExpectedMap))
			eof := false
			if _, ok := maxFailExpectedMap["!."]; ok {
				delete(maxFailExpectedMap, "!.")
				eof = true
			}
			for k := range maxFailExpectedMap {
				expected = append(expected, k)
			}
			sort.Strings(expected)
			if eof {
				expected = append(expected, "EOF")
			}
			p.addErrAt(errors.New("no match found, expected: "+listJoin(expected, ", ", "or")), p.maxFailPos, expected)
		}

		return nil, p.errs.err()
	}
	return val, p.errs.err()
}

func listJoin(list []string, sep string, lastSep string) string {
	switch len(list) {
	case 0:
		return ""
	case 1:
		return list[0]
	default:
		return fmt.Sprintf("%s %s %s", strings.Join(list[:len(list)-1], sep), lastSep, list[len(list)-1])
	}
}

func (p *parser) parseRule(rule *rule) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseRule " + rule.name))
	}

	if p.memoize {
		res, ok := p.getMemoized(rule)
		if ok {
			p.restore(res.end)
			return res.v, res.b
		}
	}

	start := p.pt
	p.rstack = append(p.rstack, rule)
	p.pushV()
	val, ok := p.parseExpr(rule.expr)
	p.popV()
	p.rstack = p.rstack[:len(p.rstack)-1]
	if ok && p.debug {
		p.print(strings.Repeat(" ", p.depth)+"MATCH", string(p.sliceFrom(start)))
	}

	if p.memoize {
		p.setMemoized(start, rule, resultTuple{val, ok, p.pt})
	}
	return val, ok
}

func (p *parser) parseExpr(expr interface{}) (interface{}, bool) {
	var pt savepoint

	if p.memoize {
		res, ok := p.getMemoized(expr)
		if ok {
			p.restore(res.end)
			return res.v, res.b
		}
		pt = p.pt
	}

	p.ExprCnt++
	if p.ExprCnt > p.maxExprCnt {
		panic(errMaxExprCnt)
	}

	var val interface{}
	var ok bool
	switch expr := expr.(type) {
	case *actionExpr:
		val, ok = p.parseActionExpr(expr)
	case *andCodeExpr:
		val, ok = p.parseAndCodeExpr(expr)
	case *andExpr:
		val, ok = p.parseAndExpr(expr)
	case *anyMatcher:
		val, ok = p.parseAnyMatcher(expr)
	case *charClassMatcher:
		val, ok = p.parseCharClassMatcher(expr)
	case *choiceExpr:
		val, ok = p.parseChoiceExpr(expr)
	case *labeledExpr:
		val, ok = p.parseLabeledExpr(expr)
	case *litMatcher:
		val, ok = p.parseLitMatcher(expr)
	case *notCodeExpr:
		val, ok = p.parseNotCodeExpr(expr)
	case *notExpr:
		val, ok = p.parseNotExpr(expr)
	case *oneOrMoreExpr:
		val, ok = p.parseOneOrMoreExpr(expr)
	case *recoveryExpr:
		val, ok = p.parseRecoveryExpr(expr)
	case *ruleRefExpr:
		val, ok = p.parseRuleRefExpr(expr)
	case *seqExpr:
		val, ok = p.parseSeqExpr(expr)
	case *stateCodeExpr:
		val, ok = p.parseStateCodeExpr(expr)
	case *throwExpr:
		val, ok = p.parseThrowExpr(expr)
	case *zeroOrMoreExpr:
		val, ok = p.parseZeroOrMoreExpr(expr)
	case *zeroOrOneExpr:
		val, ok = p.parseZeroOrOneExpr(expr)
	default:
		panic(fmt.Sprintf("unknown expression type %T", expr))
	}
	if p.memoize {
		p.setMemoized(pt, expr, resultTuple{val, ok, p.pt})
	}
	return val, ok
}

func (p *parser) parseActionExpr(act *actionExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseActionExpr"))
	}

	start := p.pt
	val, ok := p.parseExpr(act.expr)
	if ok {
		p.cur.pos = start.position
		p.cur.text = p.sliceFrom(start)
		state := p.cloneState()
		actVal, err := act.run(p)
		if err != nil {
			p.addErrAt(err, start.position, []string{})
		}
		p.restoreState(state)

		val = actVal
	}
	if ok && p.debug {
		p.print(strings.Repeat(" ", p.depth)+"MATCH", string(p.sliceFrom(start)))
	}
	return val, ok
}

func (p *parser) parseAndCodeExpr(and *andCodeExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseAndCodeExpr"))
	}

	state := p.cloneState()

	ok, err := and.run(p)
	if err != nil {
		p.addErr(err)
	}
	p.restoreState(state)

	return nil, ok
}

func (p *parser) parseAndExpr(and *andExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseAndExpr"))
	}

	pt := p.pt
	state := p.cloneState()
	p.pushV()
	_, ok := p.parseExpr(and.expr)
	p.popV()
	p.restoreState(state)
	p.restore(pt)

	return nil, ok
}

func (p *parser) parseAnyMatcher(any *anyMatcher) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseAnyMatcher"))
	}

	if p.pt.rn == utf8.RuneError && p.pt.w == 0 {
		// EOF - see utf8.DecodeRune
		p.failAt(false, p.pt.position, ".")
		return nil, false
	}
	start := p.pt
	p.read()
	p.failAt(true, start.position, ".")
	return p.sliceFrom(start), true
}

func (p *parser) parseCharClassMatcher(chr *charClassMatcher) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseCharClassMatcher"))
	}

	cur := p.pt.rn
	start := p.pt

	// can't match EOF
	if cur == utf8.RuneError && p.pt.w == 0 { // see utf8.DecodeRune
		p.failAt(false, start.position, chr.val)
		return nil, false
	}

	if chr.ignoreCase {
		cur = unicode.ToLower(cur)
	}

	// try to match in the list of available chars
	for _, rn := range chr.chars {
		if rn == cur {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	// try to match in the list of ranges
	for i := 0; i < len(chr.ranges); i += 2 {
		if cur >= chr.ranges[i] && cur <= chr.ranges[i+1] {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	// try to match in the list of Unicode classes
	for _, cl := range chr.classes {
		if unicode.Is(cl, cur) {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	if chr.inverted {
		p.read()
		p.failAt(true, start.position, chr.val)
		return p.sliceFrom(start), true
	}
	p.failAt(false, start.position, chr.val)
	return nil, false
}

func (p *parser) incChoiceAltCnt(ch *choiceExpr, altI int) {
	choiceIdent := fmt.Sprintf("%s %d:%d", p.rstack[len(p.rstack)-1].name, ch.pos.line, ch.pos.col)
	m := p.ChoiceAltCnt[choiceIdent]
	if m == nil {
		m = make(map[string]int)
		p.ChoiceAltCnt[choiceIdent] = m
	}
	// We increment altI by 1, so the keys do not start at 0
	alt := strconv.Itoa(altI + 1)
	if altI == choiceNoMatch {
		alt = p.choiceNoMatch
	}
	m[alt]++
}

func (p *parser) parseChoiceExpr(ch *choiceExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseChoiceExpr"))
	}

	for altI, alt := range ch.alternatives {
		// dummy assignment to prevent compile error if optimized
		_ = altI

		state := p.cloneState()

		p.pushV()
		val, ok := p.parseExpr(alt)
		p.popV()
		if ok {
			p.incChoiceAltCnt(ch, altI)
			return val, ok
		}
		p.restoreState(state)
	}
	p.incChoiceAltCnt(ch, choiceNoMatch)
	return nil, false
}

func (p *parser) parseLabeledExpr(lab *labeledExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseLabeledExpr"))
	}

	p.pushV()
	val, ok := p.parseExpr(lab.expr)
	p.popV()
	if ok && lab.label != "" {
		m := p.vstack[len(p.vstack)-1]
		m[lab.label] = val
	}
	return val, ok
}

func (p *parser) parseLitMatcher(lit *litMatcher) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseLitMatcher"))
	}

	ignoreCase := ""
	if lit.ignoreCase {
		ignoreCase = "i"
	}
	val := fmt.Sprintf("%q%s", lit.val, ignoreCase)
	start := p.pt
	for _, want := range lit.val {
		cur := p.pt.rn
		if lit.ignoreCase {
			cur = unicode.ToLower(cur)
		}
		if cur != want {
			p.failAt(false, start.position, val)
			p.restore(start)
			return nil, false
		}
		p.read()
	}
	p.failAt(true, start.position, val)
	return p.sliceFrom(start), true
}

func (p *parser) parseNotCodeExpr(not *notCodeExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseNotCodeExpr"))
	}

	state := p.cloneState()

	ok, err := not.run(p)
	if err != nil {
		p.addErr(err)
	}
	p.restoreState(state)

	return nil, !ok
}

func (p *parser) parseNotExpr(not *notExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseNotExpr"))
	}

	pt := p.pt
	state := p.cloneState()
	p.pushV()
	p.maxFailInvertExpected = !p.maxFailInvertExpected
	_, ok := p.parseExpr(not.expr)
	p.maxFailInvertExpected = !p.maxFailInvertExpected
	p.popV()
	p.restoreState(state)
	p.restore(pt)

	return nil, !ok
}

func (p *parser) parseOneOrMoreExpr(expr *oneOrMoreExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseOneOrMoreExpr"))
	}

	var vals []interface{}

	for {
		p.pushV()
		val, ok := p.parseExpr(expr.expr)
		p.popV()
		if !ok {
			if len(vals) == 0 {
				// did not match once, no match
				return nil, false
			}
			return vals, true
		}
		vals = append(vals, val)
	}
}

func (p *parser) parseRecoveryExpr(recover *recoveryExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseRecoveryExpr (" + strings.Join(recover.failureLabel, ",") + ")"))
	}

	p.pushRecovery(recover.failureLabel, recover.recoverExpr)
	val, ok := p.parseExpr(recover.expr)
	p.popRecovery()

	return val, ok
}

func (p *parser) parseRuleRefExpr(ref *ruleRefExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseRuleRefExpr " + ref.name))
	}

	if ref.name == "" {
		panic(fmt.Sprintf("%s: invalid rule: missing name", ref.pos))
	}

	rule := p.rules[ref.name]
	if rule == nil {
		p.addErr(fmt.Errorf("undefined rule: %s", ref.name))
		return nil, false
	}
	return p.parseRule(rule)
}

func (p *parser) parseSeqExpr(seq *seqExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseSeqExpr"))
	}

	vals := make([]interface{}, 0, len(seq.exprs))

	pt := p.pt
	state := p.cloneState()
	for _, expr := range seq.exprs {
		val, ok := p.parseExpr(expr)
		if !ok {
			p.restoreState(state)
			p.restore(pt)
			return nil, false
		}
		vals = append(vals, val)
	}
	return vals, true
}

func (p *parser) parseStateCodeExpr(state *stateCodeExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseStateCodeExpr"))
	}

	err := state.run(p)
	if err != nil {
		p.addErr(err)
	}
	return nil, true
}

func (p *parser) parseThrowExpr(expr *throwExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseThrowExpr"))
	}

	for i := len(p.recoveryStack) - 1; i >= 0; i-- {
		if recoverExpr, ok := p.recoveryStack[i][expr.label]; ok {
			if val, ok := p.parseExpr(recoverExpr); ok {
				return val, ok
			}
		}
	}

	return nil, false
}

func (p *parser) parseZeroOrMoreExpr(expr *zeroOrMoreExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseZeroOrMoreExpr"))
	}

	var vals []interface{}

	for {
		p.pushV()
		val, ok := p.parseExpr(expr.expr)
		p.popV()
		if !ok {
			return vals, true
		}
		vals = append(vals, val)
	}
}

func (p *parser) parseZeroOrOneExpr(expr *zeroOrOneExpr) (interface{}, bool) {
	if p.debug {
		defer p.out(p.in("parseZeroOrOneExpr"))
	}

	p.pushV()
	val, _ := p.parseExpr(expr.expr)
	p.popV()
	// whether it matched or not, consider it a match
	return val, true
}
